/*global document, window, console, jQuery, navigator*/
/*jslint maxlen: 150*/
/*jshint esversion:6*/

/**
 * Requirements
 *  exists.js
 **/

(function ($) {
    "use strict";

    /**
    * Extends
    **/
    $.extend({
        /**
        * Modal generator
        * @param {Object} attr_e Attributes
        */
        modal_generator: function (attr_e) {
            var attr = attr_e || {},
                ubication_c = "",
                select_close = null,
                esc_key,

                id_m = attr.id_m || "modal_1", //modal
                class_m = attr.class_m || "modal",

                id_c = attr.id_c || "content_modal", //container
                class_c = attr.class_c || "content",

                content = attr.content || "", //Content
                l_modal = attr.l_modal || "body", //Ubication

                prepend = attr.prepend || false, //prepend or append
                scroll_m = attr.scroll || false,

                close_m = attr.close_m || false, //close
                l_close = attr.l_close || "." + class_m,
                button_close = attr.button || false,
                id_b = attr.id_b || "close_1",
                class_b = attr.class_b || "close",

                top_content = attr.top_content || null,
                scroll_anim = attr.scroll_anim || false,
                vel_anim = attr.vel_anim || 800,
                close_timeout = attr.close_timeout || null,

                //Callback
                success = attr.success || function () {
                    return undefined;
                },
                cclick = attr.cclick || function () {
                    return undefined;
                },

                //Nodos
                div_modal = $("<div>", {
                    class: class_m,
                    id: id_m
                }),

                div_content = $("<div>", {
                    class: class_c,
                    id: id_c
                }),

                div_button_close = $("<div>", {
                    class: class_b,
                    id: id_b
                });

            function remove_items() {
                $("#" + id_m).remove();
                $("#" + id_c).remove();
            }

            function delete_modal() {
                if (close_timeout !== null) {
                    window.setTimeout(remove_items, close_timeout);
                } else {
                    remove_items();
                }

                cclick();
            }

            ubication_c = scroll_m
                ? l_modal
                : "." + class_m;

            //Delete modal prev
            if ($("#" + id_m).exists() || $("#" + id_c).exists()) {
                delete_modal();
            }

            //Create modal
            if (prepend) {
                $(l_modal).prepend(div_modal);
                $(ubication_c).prepend(div_content);
            } else {
                $(l_modal).append(div_modal);
                $(ubication_c).append(div_content);
            }

            //Add content
            $("#" + id_c).html(content);

            //Scroll
            if (scroll_m) {
                //Position of the content
                if (top_content !== null) {
                    $("#" + id_c).css({"top": top_content});
                }

                //Animation scroll
                if (scroll_anim) {
                    $("body, html").animate({
                        scrollTop: top_content
                    }, vel_anim);
                }
            }

            //Close modal
            if (button_close) {
                $(l_close).prepend(div_button_close);
                select_close = "." + class_m + " ." + class_b;
            }

            if (close_m) {
                select_close = "." + class_m;
            }

            $(select_close).on("click", delete_modal);

            //Key esc
            if (select_close !== null) {
                $("body").on("keyup", function (e) {
                    esc_key = ($.exists(typeof e.key))
                        ? (e.key === "Escape")
                        : (e.keyCode === 27);

                    if (esc_key) {
                        delete_modal();
                    }
                });
            }

            success();
        }
    });

    $.extend($.modal_generator, {
        exists: true,
        version: 20171030
    });

}(jQuery));
