(function (window, $, undefined) {
    'use strict'

    let NSQuestionData = {},

        select_1 = "#json-data",
        select_2 = ".content-select-request",
        select_3 = "#edit-path",
        select_4 = ".select-question",

        id_1 = "id-select-question-main";

    NSQuestionData = (function () {
        // Private
        const getProp = (obj, key) => 
            key.split('.').reduce((o, x) =>
                (typeof o == "undefined" || o === null) ? o : o[x]
                , obj);

        const createSelect = (select_id) => {
            if (!$(select_2).exists()) {
                $(select_1).after('<div class="content-select-request"></div>');
            }

            $(select_2).append('<select id="' + select_id + '" class="form-select select-question"><option value="none" data-id="0">--Seleccinar--</option></select>');
        }

        const eachObj = (select_id, json) => {
            $.each(json, (obj, ind) => {
                let classType = typeof ind,
                    suffix;

                switch (classType) {
                    case 'number':
                    case 'string':
                    case 'boolean':
                        suffix = ' (value)'
                        break;
                    case 'object':
                        suffix = ' (object)'
                        break;
                }

                if (ind !== null && ind !== '') {
                    $('#' + select_id).append('<option value="' + obj + '">' + obj + '<span>' + suffix + '</span></option>');
                }
            });
        }

        // Public 
        return {
            init: () => {
                let json = $.parseJSON($(select_1).val());

                createSelect(id_1);
                eachObj(id_1, json);

                $(document).on('change', select_4, function () {
                    let val = $(this).val(),
                        id_p = $(this).attr('id'),
                        id = 'id-' + val,
                        flag = false,
                        propObj = '',
                        pathAnswer = [];

                    $(select_2).children().each((ind, obj) => {
                        if (flag) {
                            $(obj).remove()
                        } else {
                            pathAnswer.push($(obj).val());
                            $(select_3).val(pathAnswer.join('->'));
                        }

                        if ($(obj).is('#' + id_p)) flag = true
                    });

                    propObj = getProp(json, pathAnswer.join('.'));

                    if (typeof propObj !== 'object') {
                        $(this).after('<div class="value-select">' + propObj + '</div>')
                    } else {
                        createSelect(id);
                        eachObj(id, propObj);
                    }
                });
            }
        }
    }());

    $(window).on('load', () => {
        if ($(select_1).exists()) {
            NSQuestionData.init();
        }
    });

}(window, jQuery))