/*global document, window, console, jQuery */
/*jslint maxlen: 150, this: true*/
/*jshint esversion:6*/


(function ($) {
    "use strict";

    $.extend({
        slideToUnlock: function () {
            /* Private */
            var id_form,
                class_g,
                class_s,
                class_sl,
                class_w,
                class_n,
                class_ok,
                goal_co,
                drag_obj,
                form_obj,
                slid_obj,
                goal_obj,
                note_obj,
                goal_left,
                well_obj,
                w_goal,
                message_send,
                message_ok,
                boxLeft,
                startX,
                distX,
                left_e,
                no_validation,
                no_success,
                success,
                back,
                obj_centinel = null,
                validation_1,
                centinel = true,
                devolution = true,
                position_end = 0,
                a_validation = {},
                a_modal = {};

            function dependence() {
                if (typeof jQuery !== "undefined") {
                    if (parseFloat(jQuery.fn.jquery) < 3.1) {
                        console.warn("jquery-3.1.x.js or higher is required");
                    }
                }

                if ($.fn.exists.version < 20161121) {
                    console.warn("exists.js version 20161121 or higher");
                }

                if (!($.exists(typeof $.ui))) {
                    console.warn("jquery-ui.min.js is required");
                } else if (parseFloat($.ui.version) < 1.12) {
                    console.warn("jquery-ui-min.js version 1.12 or higher");
                }

                //Optional
                if ($.exists(typeof $.modal_generator)) {
                    if ($.modal_generator.version < 20171030) {
                        console.warn("modal.js version 20171030 or higher");
                    }

                    if ($.exists(typeof $.ValidationForm)) {
                        if (!($.exists(typeof String_prototype_version))) {
                            console.warn("string.js is required");
                        }

                        if (!($.exists(typeof $.fn.preventD))) {
                            console.warn("events.js is required");
                        } else if ($.fn.preventD.version < 20170604) {
                            console.warn("events.js version 20170604 or higher");
                        }

                        validation_1 = new $.ValidationForm();
                    } else {
                        console.warn("validation.js is required");
                    }
                }
            }

            function destroy_draggable() {
                drag_obj.draggable("destroy");
                drag_obj.off("touchstart touchmove touchend");
            }

            function sending() {
                devolution = (no_validation && !back)
                    ? false
                    : (back)
                        ? true
                        : !(validation_1.start().result());

                if (no_success) {
                    destroy_draggable();
                    success();
                }
            }

            function comparison(obj, o_cen) {
                if (!obj.exists() && centinel) {
                    obj_centinel = o_cen;
                    centinel = false;
                }
            }

            function end_point() {
                w_goal = goal_obj.width() + goal_co;
                position_end = well_obj.width() - w_goal;
            }

            function touch_start(e) {
                var evento = e.originalEvent;

                e.preventDefault();
                e.stopPropagation();

                boxLeft = parseFloat(drag_obj.css("left"));
                startX = parseFloat(evento.changedTouches[0].pageX);

                //Calculating the end point
                end_point();
            }

            function touch_move(e) {
                var evento = e.originalEvent;

                e.preventDefault();
                e.stopPropagation();

                distX = parseFloat(evento.changedTouches[0].pageX) - startX;
                left_e = (boxLeft + distX > position_end)
                    ? position_end
                    : (boxLeft + distX < 0)
                        ? 0
                        : boxLeft + distX;

                drag_obj.css({left: left_e + "px"});
            }

            function touch_end(e) {
                e.preventDefault();
                e.stopPropagation();

                //If it is not in the final position return the slider
                if (Math.floor(left_e) >= Math.floor(position_end)) {
                    sending();
                }

                if (left_e < position_end || devolution) {
                    drag_obj.animate({
                        left: "0px"
                    });
                } else {
                    note_obj.html(message_ok);
                    slid_obj.addClass(class_ok);
                }

                return devolution;
            }

            function processing() {
                form_obj = $("#" + id_form);
                slid_obj = $("#" + id_form + " ." + class_sl);
                drag_obj = $("#" + id_form + " ." + class_sl + " ." + class_s);
                goal_obj = $("#" + id_form + " ." + class_sl + " ." + class_g);
                well_obj = $("#" + id_form + " ." + class_sl + " ." + class_w);
                note_obj = $("#" + id_form + " ." + class_sl + " ." + class_n);

                // Verifying the existence of the essential elements
                comparison(form_obj, "id_form");
                comparison(slid_obj, "class_sl");
                comparison(drag_obj, "class_s");
                comparison(goal_obj, "class_g");
                comparison(well_obj, "class_w");
                comparison(note_obj, "class_n");

                if (centinel) {
                    //Change the slider message
                    note_obj.html(message_send);

                    //Start move
                    move_slide();
                } else {
                    console.warn("No exists some of the elements: " + obj_centinel);
                }
            }

            function move_slide() {
                //Initialization
                goal_left = 0;
                position_end = 0;
                devolution = true;

                //Browser
                drag_obj.draggable({
                    axis: "x",
                    containment: "parent",
                    revert: function () {
                        // Realization of validation when object is dragged to the goal
                        if (Math.floor(goal_left) >= Math.floor(position_end)) {
                            sending();
                        }

                        return devolution;
                    },
                    drag: function (e, ui) {
                        end_point();
                        goal_left = ui.position.left;
                        return e;
                    },
                    stop: function () {
                        if (!devolution) {
                            note_obj.html(message_ok);
                            slid_obj.addClass(class_ok);
                        }
                    }
                });

                //Touch
                if (drag_obj.dragabble === undefined) {
                    drag_obj.on("touchstart", touch_start.bind(drag_obj));
                    drag_obj.on("touchmove", touch_move.bind(drag_obj));
                    drag_obj.on("touchend", touch_end.bind(drag_obj));
                }
            }

            /* Public */
            return {
                version: 20180409,

                init: function (attr_e) {
                    dependence();

                    var attr = attr_e || {};

                    id_form = attr.id_form || "form_1";
                    class_sl = attr.class_sl || "slidetounlock";
                    class_s = attr.class_s || "slider_unlock";
                    class_g = attr.class_g || "goal_unlock";
                    class_w = attr.class_w || "well";
                    class_n = attr.class_n || "slider_note";
                    goal_co = attr.goal_correction || 10;
                    class_ok = attr.class_ok || "ok";
                    message_send = attr.message_send || "Slide to send";
                    message_ok = attr.message_ok || "Sending";
                    no_validation = attr.no_validation || false;
                    no_success = !attr.no_success || false;
                    back = attr.back || false;
                    success = attr.success || function () {
                        return undefined;
                    };

                    if (!no_validation) {
                        a_validation = attr.attr_validation || {};
                        a_modal = attr.attr_modal || {};

                        //Values defaul modal
                        $.extend(a_modal, {
                            id_m: a_modal.id_m || "modal_form",
                            class_m: a_modal.class_m || "modal_form",
                            id_c: a_modal.id_c || "content_modal_form",
                            class_c: a_modal.class_c || "content_modal_form",
                            class_b: a_modal.class_b || "close_modal_form",
                            l_modal: a_modal.l_modal || ".content_form"
                        });

                        //Values defaul valiation
                        $.extend(a_validation, {
                            selector: a_validation.selector || "#" + id_form,
                            no_submit: a_validation.no_submit || true,
                            attr_modal: a_modal
                        });

                        validation_1.init(a_validation);
                    }

                    //Execute process
                    processing();
                },

                reload_move: function () {
                    //Remove class_ok and message_ok
                    note_obj.html(message_send);
                    slid_obj.removeClass(class_ok);

                    //Browser
                    drag_obj.animate({
                        left: "0"
                    });

                    //Start move
                    move_slide();
                },

                destroy: function () {
                    destroy_draggable();
                }
            };
        }
    });
}(jQuery));
