/*global document, window, console, jQuery*/
/*jslint maxlen: 150*/
/*jshint esversion:6*/

(function ($) {
    "use strict";

    $.extend({
        Tooltip: function () {
            /* Private */
            var class_t, //Class for the tooltip
                source_c, //Content source for the tooltip
                content_m, //Content of the tooltip
                class_ok, //Class for show tooltip
                top_a, //Top of tooltip
                left_a, //Left of tooltip
                data_n, //name of the attribute data

                a_modal; //Attributes modal


            function dependende() {
                if ($.fn.exists.version < 20161121) {
                    console.warn("exists.js version 20161121 or higher");
                }

                if (!($.exists(typeof $.modal_generator))) {
                    console.warn("modal.js is required");
                } else if ($.modal_generator.version < 20171030) {
                    console.warn("modal.js version 20171030 or higher");
                }
            }

            /* Public */
            return {
                version: 20180620,

                init: attr_e => {
                    dependende();

                    let attr = attr_e || {};

                    class_t = attr.class_t || "tooltip_js";
                    source_c = attr.source_c || "alt";
                    class_ok = attr.class_ok || "active";
                    data_n = attr.data_n || "";
                    top_a = attr.top_a || 25;
                    left_a = attr.left_a || 25;
                    a_modal = attr.attr_modal || {};

                    //Values defaul modal
                    $.extend(a_modal, {
                        id_m: a_modal.id_m || "modal_" + class_t,
                        class_m: a_modal.class_m || "modal_" + class_t,
                        id_c: a_modal.id_c || "content_" + class_t ,
                        class_c: a_modal.class_c || "content_" + class_t,
                        class_b: a_modal.class_b || "close_" + class_t,
                        l_modal: a_modal.l_modal || "." + class_t,
                        success: () => {
                            $(".modal_" + class_t).on("click", e => {
                                e.preventDefault();
                                e.stopPropagation();
                            });

                            switch (source_c) {
                                case "alt":
                                    $("." + class_t).each(function () {
                                        content_m = $(this).attr("alt");
                                        $(this).find(".content_" + class_t).html(content_m);
                                    });
                                    break;

                                case "data":
                                    $("." + class_t).each(function () {
                                        content_m = $(this).data(data_n);
                                        $(this).find(".content_" + class_t).html(content_m);
                                    });
                            }

                            $("." + class_t).each(function () {
                                let height_m,
                                    width_m,
                                    object_m,
                                    direction = $(this).data("direction"),
                                    attr_css_1 = {},
                                    attr_css_2 = {},
                                    left_ii,
                                    top_ii;

                                object_m = $(this).find(".modal_" + class_t);
                                height_m = object_m.height();
                                width_m = object_m.width();

                                if (direction === undefined) {
                                    direction = "top";
                                }

                                switch (direction) {
                                    case "right":
                                        left_ii = (-1) * (width_m + left_a + 25);
                                        attr_css_1 = { "right": left_ii};
                                        attr_css_2 = { "right": left_ii + 10};
                                    break;
                                    case "topRight":
                                    case "top":
                                    default:
                                        top_ii = (-1) * (height_m + top_a + 15);
                                        attr_css_1 = { "top": top_ii };
                                        attr_css_2 = { "top": top_ii + 15 };
                                    break;
                                }

                                object_m.css(attr_css_1);

                                $(this).on("mouseover", function () {
                                    object_m.addClass(class_ok);
                                    object_m.css(attr_css_2);
                                }).on("mouseout", function () {
                                    object_m.removeClass(class_ok);
                                    object_m.css(attr_css_1);
                                });
                            });
                        }
                    });
                    $.modal_generator(a_modal);
                }
            };
        }
    });
}(jQuery));
