/**
 * @file
 * Custom scripts for module Transformation Activation.
 */

var pageTitle = document.querySelector(".page-title");
var newItem = document.createElement("div");
var Item = document.querySelector('.block-system-main-block .link-return');
if (Item != null && newItem != null) {
    newItem.appendChild(Item);
    var list = document.getElementById("block-tigo-theme-page-title");
    list.insertBefore(newItem, list.childNodes[0]);
    pageTitle.classList.add('block-customer');
}

jQuery.getMultiScripts = function (arr, path) {
    "use strict";
    var _arr = jQuery.map(arr, function (scr) {
        return jQuery.getScript((path || "") + scr);
    });

    _arr.push(jQuery.Deferred(function (deferred) {
        jQuery(deferred.resolve);
    }));

    return jQuery.when.apply(jQuery, _arr);
};
var nombrePaginaActualConfig = "tigo.com.co";

(function ($) {
    "use strict";

    var NStransformation_activation = {},

        select_1 = "input[required]",
        select_2 = ".first_word",
        select_3 = "form.transformation-activation-activate-sim",
        select_4 = ".messages--error",
        select_5 = "form#transformation-activation-personal-data",
        select_6 = $("form.tigo-activation-personal-data .act-activate"),
        select_7 = "#edit-product .js-form-item label div",
        select_8 = ".messages__wrapper",
        select_9 = ".tigo-activation-package-detail",
        select_10 = ".close_message",
        select_11 = "#main-wrapper",
        select_12 = ".loader_tigo",
        select_13 = $(".personal-exp-year"),
        select_14 = $(".personal-exp-year .input-custom-select"),
        select_15 = $(".personal-exp-year .edit-expedition-year li"),
        select_16 = $(".personal-exp-year select[name=expedition_year]"),
        select_17 = $("form.tigo-activation-personal-data .act-continue"),
        select_18 = "#edit-email",
        select_19 = ".unlock.slidetounlock",
        select_20 = "header#header .region-navbar",
        select_21 = ".help-activation",
        select_22 = ".form-submit",
        select_23 = "#edit-return",
        select_24 = "form.tigo-activation-package-service",
        select_25 = "input[type='radio']:checked + label > div",
        select_26 = select_9 + " .description",
        select_27 = ".messages",
        select_28 = ".number-not-found",
        select_29 = ".number-content",
        select_30 = ".tigo-activation-personal-data #edit-activate",
        select_31 = ".tigo-activation-package-service .act-activate",
        select_32 = ".retract_1",
        select_33 = "item_r1",
        select_34 = "title_r1",
        select_35 = "content_r1",
        select_36 = ".retract__read__more",
        select_37 = ".title",
        select_38 = ".anexo-check",
        select_40 = ".modal_identification",
        select_43 = ".group-identification",
        select_45 = ".picture__preview",
        select_47 = ".contract-sign-step",
        select_52 = ".group-sign",
        select_57 = "form#tigo-activation-contrato .act-activate",
        select_58 = ".step_3_1",
        select_59 = ".retract__continue",
        select_60 = ".page-title",
        select_61 = ".link-return",
        select_62 = ".modal-conf-term",
        select_63 = ".notice-warning",
        select_65 = ".err_contract",
        select_66 = ".group-photo",
        select_69 = ".title > .js-form-type-checkbox",
        select_70 = ".content-title-retract",
        select_71 = ".tigo-activation-question-multi-step",
        select_72 = ".activation-form-question",
        select_73 = ".notice_step",
        select_74 = ".retract_2",
        select_75 = "item_r2",
        select_76 = "title_r2",
        select_77 = "content_r2",
        select_78 = ".tigo-activation-slide",
        select_79 = ".button--secondary",
        select_80 = ".progress-register",
        select_81 = ".progress-line",
        select_82 = ".progress-confirmation",
        select_83 = ".tigo-activation-numbers-available",
        select_84 = ".act-activate",
        select_85 = ".form-overlay",
        select_86 = "hidden",
        select_87 = ".progress-wizard",
        select_88 = ".btn-ajax",
        select_89 = ".form-modal",
        select_90 = ".btn-form",

        class_1 = "active",
        class_2 = "disabled",
        class_3 = "hide_message",
        class_4 = "is--visible",
        class_5 = "is--hide",
        class_7 = "stop_scroll_sign",
        class_8 = "picture--accept",
        class_9 = "step--disabled",
        class_12 = "active_submit_checked",
        class_13 = "modal-conf-term--open",
        class_14 = "error-step",
        class_15 = "timer_on",
        class_19 = "notice_step",
        class_20 = "slide-svg-1",
        class_21 = "slide-svg-2",
        class_22 = "slide-svg-3",
        class_23 = "enable",
        class_24 = "si",
        class_25 = "no",
        class_26 = "static",
        class_27 = "fixed",

        strike_1 = "strike_error",
        strike_2 = "strike_loader",

        loader_tigo_html = '<div class="loader_tigo"><div class="group_loader"><div class="loader-ring-light"></div><div class="loader-ring-track"></div></div><h3>Falta poco<br><b>Estamos procesando la activación de tu SIM</b></h3></div>',

        value_select,
        sActivation,
        user_id,

        number_message = 1;

    // Instance class for segment.
    if ($.exists(typeof window.sessionStorage.user_id_segment)) {
        user_id = window.sessionStorage.user_id_segment;
    }
    else if ($(select_29).exists()) {
        user_id = parseInt($(select_29).text().replace("(", "").replace(")", "").replace("-", "").replace(" ", ""), 10) || "NO ID";
        window.sessionStorage.user_id_segment = user_id;
    }
    else {
        user_id = null;
    }

    sActivation = new Segment("activacion", user_id);

    /* Build Namespace */
    NStransformation_activation = (function () {
        /* Private */
        var i;

        Array.prototype.clean = function (deleteValue) {
            for (i = 0; i < this.length; i += 1) {
                if (this[i] === deleteValue) {
                    this.splice(i, 1);
                    i -= 1;
                }
            }
            return this;
        };

        function scroll_top() {
            $("html, body").animate({
                scrollTop: "0"
            }, 300);

            return false;
        }

        /* Public */
        return {
            getConnection: function () {
                var connection = window.navigator.connection
                            || window.navigator.mozConnection
                            || null,
                    message = "",
                    div_alert;

                if (connection !== null) {
                    connection.addEventListener("typechange", function () {
                        $(".alert_js").remove();
                        if (connection.type !== "cellular" && connection.type !== undefined) {
                            if (connection.type === "wifi") {
                                message = "<h2>No identificamos la línea</h2>";
                                message += "<h3>No hemos identificado tu número de línea por favor verifica que la red</h3>";
                                message += "<ul><li>La red <b>WiFi</b> esté desactivada.</li></ul>";
                            }

                            div_alert = $("<div>", {
                                class: "fullpage_content alert_js",
                                html: "<h5>Activa tu SIM</h5><div class=\"cardtigo\">" + message + "</div>"
                            });

                            $(select_11).append(div_alert);

                            // Segment.
                            sActivation.addAttributes({
                                events: "ET - Excepción",
                                properties: {
                                    label: message,
                                    category: "Activación - Error"
                                }
                            }).sendSegment();
                        }
                    });
                    connection.dispatchEvent(new Event("typechange"));
                }
            },

            lock_button: function () {
                // Disabled slidetounlock.
                $(select_1).on("keypress keyup keydown change", function () {
                    if (!$(this)[0].validity.valid) {
                        $(select_19).addClass(class_2);
                    }
                    else {
                        $(select_19).removeClass(class_2);
                    }
                }).trigger("keypress");

                $(select_3).on("submit", function (e) {
                    e.preventDefault();
                });

                $(select_5).on("submit", function (e) {
                    if (!$(select_1)[0].validity.valid) {
                        e.preventDefault();
                    }
                });
            },

            lock_button_2: function () {
                var use1 = true,
                    use2 = true,
                    use3 = true;

                if ($(select_30).exists()) {
                    $(select_30).on("click", function (e) {
                        if (use1) {
                            use1 = false;
                        }
                        else {
                            e.preventDefault();
                        }
                    });
                }

                if ($(select_17).exists()) {
                    $(select_17).on("click", function (e) {
                        if (use2) {
                            use2 = false;
                        }
                        else {
                            e.preventDefault();
                        }
                    });
                }

                if ($(select_31).exists()) {
                    $(select_31).on("click", function (e) {
                        if (use3) {
                            use3 = false;
                        }
                        else {
                            e.preventDefault();
                        }
                    });
                }
            },

            firts_word: function () {
                $(select_2).html(function () {
                    var text = $(this).text().trim().split(" "),
                        first = text.shift();

                    return (text.length > 0
                        ? "<span class=\"first\">" + first + "</span> "
                        : first) + text.join(" ");
                });
            },

            plan_number: function () {
                var plan_number = 0;

                $(select_24 + " " + select_7).each(function () {
                    plan_number = $(this).data("value");

                    if (plan_number <= 1) {
                        $(this).addClass("hide_after");
                    }

                    plan_number = 0;
                });
            },

            three: function () {
                var strike_error = Number(window.sessionStorage.getItem(strike_1));

                if (strike_error >= 2) {
                    $.getMultiScripts([
                        "https://tigoid-cdn.tigocloud.net/misc/ZD/JS/zd_reg_co_tigo_chat.min.js?v=0.1",
                        "https://dev.zopim.com/web-sdk/1.1.3/web-sdk.js",
                        "https://www.tigo.com.co/sites/tigowebcorp.co/themes/tigo_smart/js/ChatZendeskShop.min.js"
                    ], "").done(function () {
                        // Segment.
                        sActivation.addAttributes({
                            events: "ET - Excepción",
                            properties: {
                                label: "Mostrando el chat",
                                category: "Activación - Error"
                            }
                        }).sendSegment();
                    });
                }
                else {
                    window.sessionStorage.setItem(strike_1, "1");
                }

                window.sessionStorage.setItem(strike_1, strike_error + 1);
            },

            format_description: function () {
                var descr_1 = $(select_26).html().trim(),
                    descr_2,
                    val_return = "<ul>";

                descr_2 = descr_1.split("\n").clean("");

                descr_2.forEach(function (element) {
                    val_return += "<li class=\"first_word\">" + element + "</li>";
                });

                val_return += "</ul>";

                $(select_26).html(val_return);
            },

            close_message: function () {
                var close_button = $("<div>", {
                    class: "close_message"
                });

                if (!$(select_10).exists()) {
                    $(select_8).append(close_button);
                }

                $(select_8 + " " + select_10).on("click", function () {
                    $(select_8).addClass(class_3).animate(
                        {height: 0},
                        250,
                        function () {
                            $(select_8).removeClass(class_3).removeAttr("style").remove();
                            $(select_10).remove();
                        }
                    );
                });
            },

            loader: function () {
                var strike_loader = Number(window.sessionStorage.getItem(strike_2));

                if (strike_loader < 1) {
                    window.setTimeout(function () {
                        $(select_12).remove();
                    }, 1500);

                    window.sessionStorage.setItem(strike_2, "1");
                }
                else {
                    $(select_12).remove();
                }
            },

            click_div_select: function () {
                $("body").on("click", function () {
                    select_13.removeClass(class_1);
                });

                select_6.attr("disabled", true);
                select_17.attr("disabled", true);

                select_13.on("click", function (e) {
                    e.stopPropagation();
                    select_13.toggleClass(class_1);
                });

                select_15.on("click", function (e) {
                    e.stopPropagation();
                    $(".personal-exp-year .edit-expedition-year li.active")
                        .removeClass(class_1);

                    $(this).each(function () {
                        value_select = $(this).data("value");

                        // Assignment of values.
                        select_14.attr("data-value", value_select)
                            .text(value_select);
                        $(this).addClass(class_1);

                        // Remove class.
                        select_13.removeClass(class_1).addClass("ok");
                        $(select_79).removeClass('is-disabled');
                        $(select_79).attr("disabled", false);
                        select_6.attr("disabled", false);
                        select_17.attr("disabled", false);

                        // Add class to wizard progress
                        $(select_80).addClass('enable');

                        // Change value select.
                        select_16.val(value_select);
                    });
                });
            },

            slidetounlock: function () {
                var slidetounlock_1 = new $.slideToUnlock(),
                    div_message = $("<div>", {
                        class: "messages__wrapper layout-container"
                    }),
                    div_content_message = $("<div>", {
                        class: "messages messages--error"
                    }),
                    div_close_message = $("<div>", {
                        class: "close_message"
                    });

                slidetounlock_1.init({
                    id_form: "transformation-activation-activate-sim",
                    message_send: "Desliza para continuar",
                    message_ok: "Procesando",
                    no_validation: true,
                    no_success: false,
                    back: false,
                    success: function () {
                        $.ajax({
                            url: '/servicios-transformacion/capcha/validate',
                            method: "post",
                            data: {
                                email: $(select_3 + " " + select_18).val(),
                                token: $(select_3 + " input[data-drupal-selector=edit-authentication-token]").val()
                            },
                            success: function (data) {
                                if ($.exists(data.send)) {
                                    // Segment.
                                    sActivation.addAttributes({
                                        events: "ET - Ingresar Correo",
                                        properties: {
                                            label: "Continuar",
                                            category: "Activación - Correo"
                                        }
                                    }).sendSegment();

                                    // Reload page, is neccesary for the send of data in segment.
                                    window.setTimeout(function () {
                                        window.location.href = data.send;
                                    }, 300);
                                }
                                if ($.exists(data.error)) {
                                    scroll_top();

                                    // Build Error.
                                    $(select_20).append(div_message);
                                    $(select_8).append(div_content_message);
                                    $(select_8).append(div_close_message);
                                    $(select_4).html(data.error);

                                    NStransformation_activation.close_message();
                                    NStransformation_activation.three();

                                    // Segment.
                                    sActivation.addAttributes({
                                        events: "ET - Excepción",
                                        properties: {
                                            label: data.error,
                                            category: "Activación - Correo"
                                        }
                                    }).sendSegment();

                                    slidetounlock_1.reload_move();
                                }
                            }
                        });
                    }
                });
            },

            select_number: function () {
                $(select_88).click(function(e) {
                    e.preventDefault();
                    $.ajax({
                        url: '/servicios-transformacion/number-update',
                        method: "post",
                        data: {
                            number : $('input[name="numbers"]:checked').val(),
                        },
                        success: function (data) {
                            if ($.exists(data.send)) {
                                // Reload page, is neccesary for the send of data in segment.
                                window.setTimeout(function () {
                                    window.location.href = data.send;
                                }, 300);
                            }
                            if ($.exists(data.error)) {
                                window.setTimeout(function () {
                                    window.location.href = data.error;
                                }, 300);
                            }
                        }
                    });
                });
            },

            button_help: function () {
                $(select_3 + " " + select_21).on("click", function () {
                    // Segment.
                    sActivation.addAttributes({
                        events: "ET - Otras ayudas",
                        properties: {
                            label: "Ir a otras ayudas",
                            category: "Activación - Correo"
                        }
                    }).sendSegment();
                });
            },

            button_submit_personal_data: function () {
                $(select_5 + " " + select_22).on("click", function () {
                    // Segment.
                    sActivation.addAttributes({
                        events: "ET - Activar",
                        properties: {
                            label: "Activar línea",
                            category: "Activación - Datos Cliente"
                        }
                    }).sendSegment();
                });
            },

            button_return_personal_data: function () {
                $(select_5 + " " + select_23).on("click", function () {
                    // Segment.
                    sActivation.addAttributes({
                        events: "ET - Regresar",
                        properties: {
                            label: "Volver a inicio de activación",
                            category: "Activación - Datos Cliente"
                        }
                    }).sendSegment();
                });
            },

            button_submit_activation_package: function () {
                $(select_24 + " " + select_22).on("click", function () {
                    // Segment.
                    sActivation.addAttributes({
                        events: "ET - Activar servicio",
                        properties: {
                            label: $(select_24 + " " + select_25).html(),
                            category: "Activación - Servicio"
                        }
                    }).sendSegment();
                });
            },

            tigopackage_detail: function () {
                // Segment.
                sActivation.addAttributes({
                    events: "ET - Activación pendiente",
                    properties: {
                        label: "Plan - " + $(select_26 + " ul li:first-child").text(),
                        category: "Activación - Confirmación"
                    }
                }).sendSegment();

                if ($(select_8).exists()) {
                    sActivation.addAttributes({
                        events: "ET - Excepción",
                        properties: {
                            label: $(select_8 + " " + select_27).text().trim(),
                            category: "Activación - Confirmación"
                        }
                    }).sendSegment();
                }
            },

            number_not_found: function () {
                // Segment.
                sActivation.addAttributes({
                    events: "ET - Excepción",
                    properties: {
                        label: $(select_28 + " p").text(),
                        category: "Activación - Error",
                        msisdn: "anonymousId"
                    }
                }).sendSegment();
            },

            wifi_activation: function () {
                if ($(select_3 + " input[name=wifi_unavailable]").exists()) {
                    window.sessionStorage.setItem("wifi_unavailable", true);
                }
                else if ($(select_3).exists() && !$(select_3 + " input[name=wifi_unavailable]").exists()) {
                    window.sessionStorage.removeItem("wifi_unavailable");
                }

                if (window.sessionStorage.wifi_unavailable === undefined) {
                    NStransformation_activation.getConnection();
                }
            },

            retract_main: function () {
                var retract_1,
                    retract_2;

                if ($.exists(typeof $.retract)) {
                    retract_1 = new $.retract();
                    retract_2 = new $.retract();

                    if ($(select_32).exists()) {
                        retract_1.init({
                            selector: select_32,
                            class_i: select_33,
                            class_t: select_34,
                            class_c: select_35,
                            accordion: true
                        });

                        retract_2.init({
                            selector: select_74,
                            class_i: select_75,
                            class_t: select_76,
                            class_c: select_77,
                            accordion: true
                        });

                        $(select_69).each(function () {
                            $(this).find('label').removeAttr('for');
                            $(this).parent().siblings(select_70).append($(this).find('input'));
                        });

                        $(select_37).on('click', function () {
                            var self = $(this);

                            if ($(self).hasClass(select_76)) {
                                $('.' + select_35).css('height', 'auto');
                            }

                            setTimeout(function () {
                                if (self.parent().hasClass(class_1)) {
                                    $('html, body').animate({
                                        scrollTop: self.parent().offset().top
                                    }, 800);
                                    return false
                                }
                            }, 500);
                        });

                        $(select_38).on('click', function () {
                            var countCheck = 0;

                            $(select_38).each(function (ind, obj) {
                                if ($(this)[0].checked) {
                                    countCheck += 1;
                                    if (countCheck === 4) {
                                        $(select_59).removeClass(class_2);
                                    }
                                    else {
                                        $(select_59).addClass(class_2);
                                    }
                                }
                            })
                        });
                    }
                }
            },

            timer_alert: function () {
                $(select_27).each(function () {
                    if (!$(this).hasClass(class_15)) {
                        window.setTimeout(function () {
                            this.remove();
                            $(select_8 + " " + select_10).remove();
                        }.bind($(this)), 10000);

                        $(this).addClass(class_15);
                    }
                });
            },

            build_alert_js: function (msm_e, type_e) {
                var nodo_message,
                    msm = msm_e || "",
                    type = type_e || "error";

                if (!$(select_8).exists()) {
                    $(select_20).append($("<div>", {
                        class: "messages__wrapper"
                    }));
                }

                nodo_message = $("<div>", {
                    class: "messages messages--" + type + " messages_" + number_message,
                    html: msm
                });

                $(select_8).append(nodo_message);
                NStransformation_activation.close_message(".messages_" + number_message);
                number_message = number_message + 1;
                NStransformation_activation.timer_alert();
            },

            sessionStoragePreview: function () {
                $(select_57).wrap('<div class="btn-disabled"></div>');
                $(select_57).on('click', function (e) {
                    $('body').append(loader_tigo_html);
                    $(select_45).map(function () {
                        var key = $(this).attr('class').split(' ')[1],
                            value_1 = $(this).children('img').attr('src');

                        if (value_1 !== undefined) {
                            $.storageFront().init([{
                                key: key,
                                value: value_1,
                                status: 'add'
                            }]);
                        }
                    });
                });
            },

            loadPreviewsContract: function () {
                if ($(select_8).exists()) {
                    $(select_45).map(function () {
                        var key = $(this).attr('class').split(' ')[1],
                            preview = sessionStorage.getItem(key)

                        if (preview !== null) {
                            var parentSection = $(this).parents(select_47),
                                parentsStep = $(this).parents(select_58);
                            $(this).empty().append('<img src=' + preview + '>');
                            parentSection.children().first().addClass(class_8);
                            parentSection.removeClass(class_9);
                            parentSection.siblings('.' + class_9).first().removeClass(class_9);
                            parentsStep.children().first().addClass(class_8);
                            parentsStep.removeClass(class_9);
                            $('input[type="file"]').removeAttr(class_2);
                        }
                    });

                    $(select_65).map(function () {
                        var dataError = $(this).attr('data-error');
                        switch (dataError) {
                            case '1':
                                $(select_66).addClass(class_14)
                                break;

                            case '2':
                                $(select_52).addClass(class_14)
                                break;

                            case '3':
                                $(select_43 + ', ' + select_40).addClass(class_14)
                                break;

                            default:

                        }
                    })
                }
                else {
                    ['camera','pencil','identification-frontal','lateral-id-lateral', 'frontal-id-frontal'].map(function (obj) {
                        if (sessionStorage.getItem(obj) !== null) {
                            $.storageFront().init([{
                                key: obj,
                                status: 'remove'
                            }]);
                        }
                    })
                }
            },

            terms_n_conditions: function () {
                $('input[type="checkbox"]').prop('checked', false);
                $('input[type="checkbox"]').on('change', function () {
                    var parentCheck = $(this).parent();
                    parentCheck.toggleClass(class_12);

                    if (parentCheck.hasClass(class_12)) {
                        parentCheck.siblings().children().unwrap();
                    }
                    else {
                        parentCheck.siblings().wrap('<div class="btn-disabled"></div>');
                    }
                });
            },

            slide: function () {
                lottie.loadAnimation({
                    container: document.getElementById(class_20),
                    renderer: 'svg',
                    loop: true,
                    autoplay: true,
                    path: "/modules/custom/transformation_activation/images/json/slide_01.json",
                    rendererSettings: {
                        className: 'custom-slide'
                    }
                });
                lottie.loadAnimation({
                    container: document.getElementById(class_21),
                    renderer: 'svg',
                    loop: true,
                    autoplay: true,
                    path: "/modules/custom/transformation_activation/images/json/slide_02.json",
                    rendererSettings: {
                        className: 'custom-slide'
                    }
                });
                lottie.loadAnimation({
                    container: document.getElementById(class_22),
                    renderer: 'svg',
                    loop: true,
                    autoplay: true,
                    path: "/modules/custom/transformation_activation/images/json/slide_03.json",
                    rendererSettings: {
                        className: 'custom-slide'
                    }
                });

                $(select_78).slick({
                    dots: true,
                    arrows: false,
                });
            },

            wizard_progress: function () {
                if ($(select_83).exists()) {
                    $(select_80).addClass(class_23);
                }
                $('input:radio[name="numbers"]').change(
                    function () {
                        $('.btn-form .act-activate').removeClass('disable');
                        $(select_81).addClass(class_23);
                    }
                );
            },

            // modal_third_service: function () {
            //     $(select_84).on("click", function (e) {
            //         $(select_85).show();
            //     });
            //     $('input:radio[name="use"]').change(
            //         function () {
            //             if (this.checked && this.value == class_25) {
            //                 $(select_89).show(300, 'swing', function () {
            //                     $(select_90).hide();
            //                     $(select_85).css({ position: class_26 });
            //                 });
            //             }
            //             if (this.checked && this.value == class_24) {
            //                 $(select_89).hide(300, 'swing', function () {
            //                     $(select_90).show();
            //                     $(select_85).css({ position: class_27 });
            //                 });
            //             }
            //         },
            //     );
            // },
        };
    }());

    function proccess_ajax() {
        if ($(select_8).exists() && $(select_72).exists()) {
            $(select_8).appendTo(select_20);
            NStransformation_activation.close_message(select_8);
            NStransformation_activation.timer_alert();
            $('body, html').animate({
                scrollTop: $(select_8).offset().top
            }, 800);
        }
    }

    $.fn.stepTryAgain = function (success) {
        if (success) {
            $(select_71).addClass(class_19);
            $(select_60).hide();
            $(select_61).css({
                'margin-bottom': '32px',
                'height': '16px'
            });
            $('body, html').animate({
                scrollTop: $(select_73).offset().top - 10
            }, 800);
            // Show chat.
            if ($(select_63).exists()) {
                $.getMultiScripts([
                    "https://tigoid-cdn.tigocloud.net/misc/ZD/JS/zd_reg_co_tigo_chat.min.js?v=0.1",
                    "https://dev.zopim.com/web-sdk/1.1.3/web-sdk.js",
                    "https://www.tigo.com.co/sites/tigowebcorp.co/themes/tigo_smart/js/ChatZendeskShop.min.js"
                ], "");
            }
        }
    }

    proccess_ajax();

    (function ($, Drupal, drupalSettings) {
        Drupal.behaviors.activation = {
            attach: function (context, settings) {
                proccess_ajax();
            }
        };
    })(jQuery, Drupal, drupalSettings);

    $(window).on("load", function () {
        NStransformation_activation.wifi_activation();

        if ($(select_1).exists()) {
            NStransformation_activation.lock_button();
        }

        if ($(select_24 + " " + select_7).exists()) {
            NStransformation_activation.plan_number();
        }

        if ($(select_8).exists()) {
            NStransformation_activation.three();
            NStransformation_activation.close_message();
        }
        else {
            window.sessionStorage.removeItem(strike_1);
        }

        if ($(select_9).exists()) {
            NStransformation_activation.format_description();
            NStransformation_activation.tigopackage_detail();
        }

        if ($(select_2).exists()) {
            NStransformation_activation.firts_word();
        }

        if (select_13.exists()) {
            NStransformation_activation.click_div_select();
        }

        if ($.exists(typeof $.slideToUnlock)
                && $(select_3).exists()
                && $(select_19).exists()) {
            NStransformation_activation.slidetounlock();
        }

        if ($(select_3 + " " + select_21).exists()) {
            NStransformation_activation.button_help();
        }

        if ($(select_5 + " " + select_22).exists()) {
            NStransformation_activation.button_submit_personal_data();
        }

        if ($(select_5 + " " + select_23).exists()) {
            NStransformation_activation.button_return_personal_data();
        }

        if ($(select_24 + " " + select_22).exists()) {
            NStransformation_activation.button_submit_activation_package();
        }

        if ($(select_28).exists()) {
            NStransformation_activation.number_not_found();
        }

        if ($(select_30).exists() || $(select_17).exists() || $(select_31).exists()) {
            NStransformation_activation.lock_button_2();
        }

        // You should always go to the end.
        if ($(select_12).exists()) {
            NStransformation_activation.loader();
        }

        if ($(select_32).exists()) {
            NStransformation_activation.retract_main();
        }

        if ($(select_36).exists()) {
            NStransformation_activation.showRetract();
        }

        if ($(select_57).exists()) {
            NStransformation_activation.sessionStoragePreview();
        }

        if ($(select_45).exists()) {
            NStransformation_activation.loadPreviewsContract();
            NStransformation_activation.terms_n_conditions();
        }

        if ($(select_78).exists()) {
            NStransformation_activation.slide();
        }

        if ($(select_87).exists()) {
            NStransformation_activation.wizard_progress();
        }

        if ($(select_84).exists()) {
            NStransformation_activation.modal_third_service();
        }

        if ($(select_83).exists()) {
            NStransformation_activation.select_number();
        }

    });
}(jQuery));
