<?php

namespace Drupal\transformation_activation;

//require $_SERVER['DOCUMENT_ROOT'] . "/vendor/setasign/eval/setapdf-signer/ioncube/php7.1/library/SetaPDF/Autoload.php";

use Drupal\tigo_helpers\Controller\HelpersController;
use Drupal\Core\Render\Markup;
use Drupal\tigo_s3\S3;
use Drupal\transformation_activation\GeneratePdf;
use Drupal\transformation_activation\GenerateXml;
//use SetaPDF_Core_Writer_File;
//use SetaPDF_Core_Document;
//use SetaPDF_Signer;
//use SetaPDF_Signer_Signature_Module_OpenSsl;

class Activation
{

    /**
     * Insert Log
     */
    public static function queryInsertLog($date, $order_id, $email, $log_enconde){
        $connection = \Drupal::database();
        $_SESSION['step_log'] = $log_enconde;
        $insert = $connection->insert('transformation_activation_log')
            ->fields(['created', 'order_id', 'mail', 'log'])
            ->values([
                'created' => $date,
                'order_id' => $order_id,
                'mail' => $email,
                'log' => $log_enconde
            ])
            ->execute();
    }

    /**
     * Update Log
     */
    public static function queryLogUpdate($email, $date, $log, $id = FALSE)
    {
        if($id){
            $id = str_replace('WSEC', '', $id);
            $id = explode('P', $id);
            $fields = [
                'order_id' => $id[0],
                'log' => $log
            ];
        }else{
            $fields = [
                'log' => $log
            ];
        }

        $_SESSION['step_log'] = $log;

        $connection = \Drupal::database();
        try {
            $update = $connection->update('transformation_activation_log')
                ->fields($fields)
                ->condition('created', $date)
                ->condition('mail', $email)
                ->execute();
        } catch (\Exception $e) {

        }
    }

    public static function updateStatusActivationVtex ($data, $code)
    {
        $transactionID = str_replace('WSEC', '', $data['transactionId']);
        $transaction = explode('P', $transactionID);
        $productid = explode('I', $transaction[1]);
        $connection = \Drupal::database();
        if(isset($data['msisdn']) && isset($data['imsi'])){
            $query = db_select('vtex_orders', 'vo');
            $query->addField('vo', 'try');
            $query->condition('vo.sequence', $transaction[0], '=');
            $query->condition('vo.product_id', $productid[0], '=');
            $result = $query->execute()->fetchObject();
            $count = 1;
            if($result && $result->try){
                $count =   $result->try + 1;
            }
            try {
                $update = $connection->update('vtex_orders')
                    ->fields([
                        'activation_status' => $code,
                        'msisdn' => $data['msisdn'],
                        'imsi' => $data['imsi'],
                        'try' => $count
                    ])
                    ->condition('sequence', $transaction[0])
                    ->condition('product_id', $productid[0])
                    ->condition('status', 'invoiced')
                    ->execute();
            } catch (\Exception $e) {

            }
        }else{
            try {
                $update = $connection->update('vtex_orders')
                    ->fields([
                        'activation_status' => $code,
                    ])
                    ->condition('sequence', $transaction[0])
                    ->condition('product_id', $productid[0])
                    ->condition('status', 'invoiced')
                    ->execute();
            } catch (\Exception $e) {

            }
        }
    }

    /**
     * Update Log
     */
    public static function activateSim($response, $data, $step)
    {
        $logDate = isset($_COOKIE['Drupal_visitor_date'])
            ? $_COOKIE['Drupal_visitor_date']
            : '';
        $logLog = isset($_SESSION['step_log'])
            ? (array) json_decode($_SESSION['step_log'])
            : '';
        $personalEmail = isset($_COOKIE['Drupal_visitor_client_email'])
            ? $_COOKIE['Drupal_visitor_client_email']
            : '';
        $get_message = (method_exists($response, 'getMessage'))
            ? json_decode($response->getMessage())
            : $response;
        if($step == 2){
            $logLog[] = [
                'step' => $step,
                'log' => $get_message->payload->description,
                'code' => $get_message->payload->msgCode,
                'productid' => $data['productId'],
                'data' => json_encode($data)
            ];
        }else{
            $logLog[] = [
                'step' => $step,
                'log' => $get_message->payload->description,
                'code' => $get_message->payload->msgCode,
                'productid' => $data['productId']
            ];
        }

        $log_enconde = json_encode($logLog);
        self::queryLogUpdate($personalEmail, $logDate, $log_enconde, $data['transactionId']);
        self::updateStatusActivationVtex($data, $get_message->payload->msgCode);

        switch ($get_message->payload->msgCode){
            case 210:
                drupal_set_message(Markup::create(
                    '<em>Importante</em>
                    <div>¡Tu SIM se encuentra en proceso de activación!</div>
                    <p>Recuerda <b>REINICIAR</b> el equipo para disfrutar de tus servicios. Al hacerlo recibirás un <b>SMS confirmando tu activación.</b></p>'
                ), 'reload');
                break;
            default:

                drupal_set_message($get_message->payload->description, "status");
                break;
        }
    }

    public static function queryOrderIdByEmail($email, $status = FALSE){
        $query = db_select('vtex_orders', 'vo');
        $query->addField('vo', 'order_id');
        $query->addField('vo', 'status');
        $query->addField('vo', 'date_retry');
        $query->condition('vo.client_email', $email, '=');
        $query->condition('vo.activation_status', self::validCodeActivation(), 'NOT IN');
        if($status){
            $query->condition('vo.status', 'invoiced', '=');
        }
        $result = $query->execute()->fetchObject();
        return $result;
    }

    public static function validCodeActivation(){
        return [210, 100, -100];
    }

    /*
     * Function clearNumber
     * Limpia cualquier caracter que no sea de tipo númerico, incluidos espacios
     * @param string $number Es el string inicial que se va a limpiar
     * @return int
     */

    public static function clearNumber($number) {
        $clearNumber = preg_replace('([^0-9])', '', $number);
        return $clearNumber;
    }

    public static function validateTigoNumber($msisdn) {
        $type = 'account';
        $api = \Drupal::service('tigoapi.api');
        $params['tokens'] = [
          'clientId' => $msisdn,
          'type' => $type
        ];
        try {
            $numeroTigo = $api->consumption('upselling', $params);
            //$numeroTigo = 'num';
        } catch (\Exception $e) {
            return false;
        }
        return $numeroTigo;
    }

    public static function validateToken(){
        $uri = 'private://ActivationValidate.txt';
        $output = [];
        $flag = FALSE;
        $file = fopen($uri, "r") or exit("Unable to open file!");
        //Output a line of the file until the end is reached
        while ($linea = fgets($file))
        {
            if (trim($linea) == $_SESSION['activation_token'])
            {
                $flag = TRUE;
            }elseif (!empty($linea)){
                $output[] = $linea;
            }
        }
        fclose($file);
        $result = implode($output, "");
        file_put_contents($uri, $result);
        return $flag;
    }

    public static function CallBackActivation($transactionid, $code, $msisdn, $description){
        $data = [
            'transactionId' => $transactionid
        ];
        $message = "";

        $base_url = 'https://transacciones.tigo.com.co';

        if($code == "957"  || $code == "045" || $code == "45"){

            $tokens = [
                '@url' => t($base_url . '/servicios/activate?code='.$code),
            ];

            $message = t('Lo sentimos, en este momento nuestro servicio de activacion se encuentra en mantenimiento. Por favor intenta mas tarde ingresando nuevamente a @url',
                $tokens
            );
            // Set sms $var's.
            $config = \Drupal::service('config.factory')->getEditable('tigo_vtex_api.settings');
            $tigo_act_settings = $config->get('tigo_act_settings');
            $tigo_act_settings['options']['maintenance_mode'] = strtotime(date('d F Y', strtotime("+1 day")));
            $config->set('tigo_act_settings', $tigo_act_settings);
            $config->save();

            //Send email
            $config = \Drupal::config('tigo_vtex_api.settings');
            $settings = $config->get('tigo_act_settings');
            $mailManager = \Drupal::service('plugin.manager.mail');
            $module = 'transformation_activation';
            $key = 'notification_activation';
            $to = !empty($settings['service']['emails'])
                ? $settings['service']['emails']
                : 'lina.breton@tigoune.com';
            $params['message'] = 'Vendedor No tiene cupo o No existe en EPOS';
            $params['title'] = 'Tigo: activacion a entrado en estado de mantenimiento error 957';
            $langcode = \Drupal::currentUser()->getPreferredLangcode();
            $send = true;
            $result = $mailManager->mail($module, $key, $to, $langcode, $params, NULL, $send);
        }
        elseif($code == "986") {
            $message = t('Presentamos problemas con la SIM; pero no te preocupes, te enviaremos una nueva SIM gratis para que puedas activarte de una!');
        }
        elseif($code == "086") {
            $tokens = [
                '@url' => t($base_url . '/servicios/activate?code=086'),
            ];
            $message = t('Por favor verifica tu año de expedicion de tu documento de identidad e ingrasala de nuevo en @url para que puedas activarte.', $tokens);
        }
        self::updateStatusActivationVtex($data, $code);

        // Send SMS if activation fail.
        if($code != 100) {
            $tokens = [
                '@url' => t($base_url . '/servicios/activate?code='.$code),
            ];

            $message_default = t('Presentamos problemas con la activacion de tu SIM. Por favor intenta mas tarde ingresando nuevamente a @url',
                $tokens
            );

            $message = empty($message)
                ? $message_default
                : $message;
            $params['tokens'] = [
                'clientId' => $msisdn,
                'sms' => rawurlencode($message),
            ];
            try {
                \Drupal::service('tigoapi.api')->consumption('SendSms', $params);
            }
            catch(\Exception $e) {
            }
            unset($params);
        }

        // Activate package if activation is success.
        if($code == 100) {
            $data = [
                'Category' => 'Activación',
                'Label' => "Activación exitosa",
                'Code' => "100",
                'Msisdn'=> $msisdn
            ];
            $helpers = new HelpersController();
            $segment = $helpers->segment_instance();
            $response = $segment->tracking_data_segment_generic(
                $msisdn,
                "ET - Activación",
                $data
            );

            $log_data = [
                'msisdn' => $msisdn,
                'transacctionId' => $transactionid,
            ];


            $query = db_select('vtex_orders', 'vo');
            $query->addField('vo', 'imsi');
            $query->addField('vo', 'client_email');
            $query->addField('vo', 'client_name');
            $query->join('vtex_packages', 'vp', 'vo.product_id = vp.vtex_plan_id');
            $query->condition('vo.msisdn', $msisdn, '=');
            $result = $query->execute()->fetchObject();
            if($result && $result->imsi){
                $log_data['plan'] = 'Pospago';
                sleep(5);
                $tmp_pdf_file = file_directory_temp() . '/'. $result->imsi .'.pdf';
                $tmp_xml_file = file_directory_temp() . '/'. $result->imsi .'.xml';
                /*$seta_file = file_directory_temp() . '/'. $result->imsi .'-sign.pdf';
                $document = SetaPDF_Core_Document::loadByFilename($tmp_file, new SetaPDF_Core_Writer_File($seta_file));

                $signer = new SetaPDF_Signer($document);

                // set some signature properties
                $signer->setReason('tigo');
                $signer->setLocation('www.tigo.com');
                $signer->setTimestampModule();

                $module = new SetaPDF_Signer_Signature_Module_OpenSsl();

                $certificate = drupal_get_path('module', 'transformation_activation').'/certificate_ssl/nginx.crt';

                $module->setCertificate(file_get_contents($certificate));

                $private = drupal_get_path('module', 'transformation_activation').'/certificate_ssl/nginx.key';

                $module->setPrivateKey(array(file_get_contents($private), ''));

                $signer->sign($module);*/
                if(file_exists($tmp_pdf_file)){
                    $obj = new S3();
                    $obj->sendFile($result->imsi . '.pdf', $tmp_pdf_file);
                    $obj->sendFile($result->imsi . '.xml', $tmp_xml_file);
                    //send mail
                    $mailManager = \Drupal::service('plugin.manager.mail');
                    $module = 'transformation_activation';
                    $key = 'email_contract';
                    $to = $result->client_email;
                    global $base_url;
                    $message = [
                        '#theme' => 'tigo-activation-email',
                        '#name' => $result->client_name,
                        '#msisdn' => self::formatMsisdn($msisdn),
                        '#base_url' => $base_url,
                    ];
                    $message = drupal_render($message);

                    $stylesheet = file_get_contents(drupal_get_path('module', 'transformation_activation').'/css/email.css');
                    $params['message'] = $message;
                    $params['title'] = $result->imsi;
                    $langcode = \Drupal::currentUser()->getPreferredLangcode();
                    // Attach pdf file to email params
                    $file = new \stdClass();
                    $file->filepath = $tmp_pdf_file;
                    $file->filename = $result->imsi . '.pdf';
                    $file->filemime = 'application/pdf';
                    $params['attachments'][] = $file;
                    $params['css'] = $stylesheet;
                    $mailManager->mail($module, $key, $to, $langcode, $params, NULL, TRUE);
                }

            }else{
                $log_data['plan'] = 'Prepago';
                \Drupal::service('tigo_ativation.ativation_process')->packageActivation($msisdn);
            }
            $query_log = db_select('vtex_orders', 'vo');
            $query_log->addField('vo', 'client_email');
            $query_log->addField('vo', 'sequence');
            $query_log->condition('vo.msisdn', $msisdn, '=');
            $result_log = $query_log->execute()->fetchObject();


            $log = [
                'step' => 'Activación exitosa',
                'data' => json_encode($log_data)
            ];
            self::queryInsertLog(date('Y-m-d H:i:s'), $result_log->sequence, $result_log->client_email, json_encode([$log]));

        }
    }

    public static function formatMsisdn($msisdn){
        $pattern = '/([0-9]{3})([0-9]{3})([0-9]{4})/i';
        $substitute = '($1) $2-$3';

        return preg_replace($pattern, $substitute, $msisdn);
    }

    public static function SubmitGeneratePdf(){
        if(isset($_SESSION['data_pospago'])){
            $info = $_SESSION['data_pospago'];
            if(isset($info['moreData']['real_order_id'])){
                $more_info = self::queryData($info['moreData']['real_order_id']);
                if(isset($info['productId'])){
                    $query = db_select('vtex_packages', 'vp');
                    $query->addField('vp', 'plan_id');
                    $query->addField('vp', 'plan_name');
                    $query->addField('vp', 'plan_price');
                    $query->addField('vp', 'plan_details');
                    $query->condition('vp.vtex_plan_id', $info['productId'], '=');
                    $result = $query->execute()->fetchObject();
                    if($result){
                        $detalles = json_decode($result->plan_details);
                        $details = [];
                        foreach ($detalles as $detalle){
                            $details[$detalle->tipo][] = [
                                'item' => $detalle->item,
                                'price' => $detalle->price
                            ];
                        }

                        $data = [
                            'contrato' => $info['imsi'],
                            'msisdn' => $info['msisdn'],
                            'fijo' => $more_info['client_phone'],
                            'precio' => $result->plan_price,
                            'nombre_plan' => $result->plan_name,
                            'movil_adicional' => $more_info['client_phone'],
                            'barrio' => $more_info['neighborhood'],
                            'codigo_postal' => $more_info['postalCode'],
                            'nombre' => $info['moreData']['name'],
                            'documento' => $info['docId'],
                            'correo' => $info['moreData']['email'],
                            'direccion' => $more_info['street'],
                            'departamento' => $more_info['state'],
                            'ciudad' => $more_info['city'],
                            'referencias' => [
                                1 => [
                                    'nombre' => '',
                                    'parentesco' => '',
                                    'telefono' => ''
                                ],
                                2 => [
                                    'nombre' => '',
                                    'parentesco' => '',
                                    'telefono' => ''
                                ]
                            ],
                            'contacto_autorizado' => [
                                'nombres' => "",
                                'tipo_documento' => "",
                                'numero_documento' => "",
                                'telefono' => "",
                                'celular' => "",
                                'cod_postal' => ""
                            ],
                            'detalles' => $details,
                            'firma' => $_SESSION['path_firma'],
                            'foto' => $_SESSION['path_photo_selfie'],
                            'imagen_documento_1' => $_SESSION['path_identification_front'],
                            'imagen_documento_2' => $_SESSION['path_identification_back'],
                            'renovacion' => $info['moreData']['anexos']['renovacion'],
                            'disposicion' => $info['moreData']['anexos']['disposicion'],
                            'factura_electronica' => $info['moreData']['anexos']['factura_electronica']
                        ];

                        $generate_pdf = new GeneratePdf($data);
                        $generate_pdf->pdf();

                        $generate_xml = new GenerateXml($data);
                        $generate_xml->xml();

                        $config = \Drupal::config('tigo_vtex_api.settings');
                        $settings = $config->get('tigo_act_settings');

                        $logDate = isset($_COOKIE['Drupal_visitor_date'])
                            ? $_COOKIE['Drupal_visitor_date']
                            : '';
                        $logLog = isset($_SESSION['step_log'])
                            ? (array) json_decode($_SESSION['step_log'])
                            : '';
                        $logLog[4] = [
                            'step' => 'Firma Contrato',
                            'log' => 'Validacion campos ',
                            'data' => json_encode([
                                'foto' => 'Correcto',
                                'firma' => 'Correcto',
                                'Cedula' => 'Correcto'
                            ])
                        ];
                        $log_enconde = json_encode($logLog);
                        self::queryLogUpdate($info['moreData']['email'], $logDate, $log_enconde);

                        if($settings['options']['debug_mode'] != 1) {
                            $service = \Drupal::service('tigo_ativation.ativation_process');

                            // Call to activation service
                            $service->activation($info);
                            $response = $service->getResponse();

                            self::activateSim($response, $info, 5);
                        }else{
                            drupal_set_message(Markup::create(
                                '<em>Modo Debug</em>
                                <div>¡Tu SIM se encuentra en proceso de activación!</div>
                                <p>Recuerda <b>REINICIAR</b> el equipo para disfrutar de tus servicios. Al hacerlo recibirás un <b>SMS confirmando tu activación.</b></p>'
                            ), 'reload');
                        }
                    }
                }
            }
        }
    }

    public static function queryData($order_id){
        $query = db_select('vtex_orders', 'vo');
        $query->addField('vo', 'json_address');
        $query->addField('vo', 'client_phone');
        $query->condition('vo.order_id', $order_id, '=');
        $result = $query->execute()->fetchObject();
        $return = (array) json_decode($result->json_address);
        $return['client_phone'] = $result->client_phone;
        return $return;
    }
}


