<?php

namespace Drupal\transformation_activation\Button;

use Drupal\transformation_activation\Step\StepsEnum;

/**
 * Class StepThreeFinishButton.
 *
 * @package Drupal\transformation_activation\Button
 */
class StepThreeFinishButton extends BaseButton {

  /**
   * {@inheritdoc}
   */
  public function getKey() {
    return 'finish';
  }

  /**
   * {@inheritdoc}
   */
  public function build() {
    return [
      '#type' => 'submit',
      '#value' => 'Continuar',
      '#goto_step' => StepsEnum::STEP_FINALIZE,
      '#submit_handler' => 'submitValues',
      '#attributes' => [
        'class' => ['btn-tigo btn-tigo--blue']
      ],
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function getSubmitHandler() {
    return 'submitIntake';
  }

}
