<?php

namespace Drupal\transformation_activation\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\transformation_activation\Activation;

class FailTransformation extends ControllerBase {

  /**
   * {@inheritdoc}
   */
  public function View() {
    $tempstore = \Drupal::service('tempstore.private');
    $store     = $tempstore->get('transformation_activation');
    $config    = \Drupal::config('tigo_vtex_api.settings');
    $settings  = $config->get('tigo_act_settings');

    // Storage.
    $data = [
      'basket_id' => (NULL ==! $store->get('basket_id'))
      ? $store->get('basket_id') : '',
      'account_id' => (NULL ==! $store->get('account_id_find'))
      ? $store->get('account_id_find') : '',
      'msisdn' => isset($_COOKIE['Drupal_visitor_msisdn'])
      ? $_COOKIE['Drupal_visitor_msisdn'] : '',
      'client_email' => (NULL ==! $store->get('client_email'))
      ? $store->get('client_email') : '',
      'real_msisdn' => (NULL ==! $store->get('real_msisdn'))
      ? $store->get('real_msisdn') : '',
      'date' => (NULL ==! $store->get('date'))
      ? $store->get('date') : '',
      'iccid' => (NULL ==! $store->get('iccid'))
      ? $store->get('iccid') : NULL,
      'product_id_reference' => (NULL ==! $store->get('product_id_reference'))
      ? $store->get('product_id_reference') : NULL,
      'reference_number' => (NULL ==! $store->get('reference_number'))
      ? $store->get('reference_number') : NULL,
    ];

    $step = ($settings['options']['debug_mode'] != 1)
    ? 'Activacion exitosa' : 'Modo debug';
    $logLog = [
      'step' => $step,
      'log' => (NULL ==! $store->get('error')) ? $store->get('error') : NULL,
      'data' => json_encode($data),
    ];
    $log_enconde = json_encode($logLog);

    Activation:: queryLogUpdate($data['client_email'], $data['date'], $log_enconde);
    \Drupal::logger('orders')->notice(print_r($data, 1));

    return [
      '#theme' => 'transformation-activation-fail-activation',
      '#attached' => array(
        'library' => array(
          'transformation_activation/transformation_activation',
        ),
      ),
    ];
  }
}
