<?php
/**
 * @file
 * Contains \Drupal\tigo_vtex_manage_orders\Controller\InvoiceTable
 */
namespace Drupal\transformation_activation\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\Core\Url;

class KeepInMind extends ControllerBase
{

    public function View() {
        $output['#attached']['library'][] = 'transformation_activation/transformation_activation';
        $output['container2'] = array(
            '#type' => 'container',
            '#attributes' => array(
                'class' => array('recommendation')
            )
        );
        $output['container2']['title'] = [
            '#markup' => "<h5>!Ten en cuenta antes de activarte!</h5>"
        ];

        $output['container2']['container'] = array(
            '#type' => 'container',
            '#attributes' => array(
                'class' => array(
                    'cardtigo',
                    'cardtigo_shadow',
                    'no-line'
                )
            )
        );

        $output['container2']['container']['items'] = [
            '#theme' => 'item_list',
            '#items' => [
                'wifi' => [
                    'data' => [
                        '#type' => 'markup',
                        '#markup' => '<p>Verifica que tu red WIFI y opción modo avión <b>esten desactivados</b></p>'
                    ],
                    '#wrapper_attributes' => [
                        'class' => 'mind-wifi',
                    ]
                ],
                'mobile' => [
                    'data' => [
                        '#type' => 'markup',
                        '#markup' => '<p>Verifica que tus datos móviles esté en <b>modo activo</b></p>'
                    ],
                    '#wrapper_attributes' => [
                        'class' => 'mind-data',
                    ]
                ],
                'double-sim' => [
                    'data' => [
                        '#type' => 'markup',
                        '#markup' => '<p>Si tienes dos SIM en tu equipo retira la que tienes en uso y conserva <b>únicamente la que quieres activar</b></p>'
                    ],
                    '#wrapper_attributes' => [
                        'class' => 'mind-doble-sim',
                    ]
                ],
                'sim' => [
                    'data' => [
                        '#type' => 'markup',
                        '#markup' => '<p>Verifica que hayas insertado correctamente la <b>SIM de Tigo</b></p>'
                    ],
                    '#wrapper_attributes' => [
                        'class' => 'mind-sim',
                    ]
                ]
            ]
        ];
        $output['container2']['container']['link'] = [
            '#type' => 'link',
            '#title' => 'ACTIVARME',
            '#url' => Url::fromRoute('transformation_activation.activate_sim')
        ];

        return $output;
    }
}
