<?php

namespace Drupal\transformation_activation\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\transformation_activation\ValidateActivation;
use Drupal\transformation_activation\Activation;

/**
 * Controller routines for page example routes.
 */
class PackageDetail extends ControllerBase {

  /**
   * {@inheritdoc}
   */
  protected function getModuleName() {
    return 'transformation_activation_desktop_device';
  }


  /**
   * Constructs a simple page.s
   *
   * The router _controller callback, maps the path
   *
   * _controller callbacks return a renderable array for the content area of the
   * page. The theme system will later render and surround the content with the
   * appropriate blocks, navigation, and styling.
   */
  public function View() {
    // $validate = ValidateActivation::buildValidate();

    // if($validate){
    //   return $validate;
    // }

    ValidateActivation::validateMail();
    \Drupal::service('page_cache_kill_switch')->trigger();
    $tempstore = \Drupal::service('tempstore.private');
    $store = $tempstore->get('transformation_activation');
    $real_msisdn = (NULL ==! $store->get('real_msisdn'))
    ? $store->get('real_msisdn') : '';
    $product_id = (NULL ==! $store->get('product_id'))
    ? $store->get('product_id') : '';
    $prefix = substr($real_msisdn, 0, 2);
    $numbers = ValidateActivation::FormatNumber($real_msisdn, $prefix);
    $config = \Drupal::config('tigo_vtex_api.settings');
    $tigo_act_settings = $config->get('tigo_act_settings');

    // Storage.
    $data = [
      'basket_id' => (NULL ==! $store->get('basket_id'))
      ? $store->get('basket_id') : '',
      'account_id' => (NULL ==! $store->get('account_id_find'))
      ? $store->get('account_id_find') : '',
      'msisdn' => isset($_COOKIE['Drupal_visitor_msisdn'])
      ? $_COOKIE['Drupal_visitor_msisdn'] : '',
      'client_email' => (NULL ==! $store->get('client_email'))
      ? $store->get('client_email') : '',
      'real_msisdn' => $real_msisdn,
      'date' => (NULL ==! $store->get('date'))
      ? $store->get('date') : '',
      'iccid' => (NULL ==! $store->get('iccid')) ? $store->get('iccid') : '',
      'product_id_reference' => (NULL ==! $store->get('product_id_reference'))
      ? $store->get('product_id_reference') : '',
      'reference_number' => (NULL ==! $store->get('reference_number'))
      ? $store->get('reference_number') : NULL,
    ];

    $logLog = [
      'step' => 4,
      'log' => 'Activacion exitosa',
      'data' => json_encode($data),
    ];
    $log_enconde = json_encode($logLog);

    Activation::queryLogUpdate($data['client_email'], $data['date'], $log_enconde);
    \Drupal::logger('orders')->notice(print_r($data, 1));

    $output = [
        '#theme' => 'transformation-activation-package-detail',
        '#package_capacity' => $product_id,
        '#phone' => $numbers,
        '#attached' => array(
            'library' => array(
                'transformation_activation/transformation_activation',
            ),
        ),
    ];
    $output = ValidateActivation::_hsq($output);

    // Delete cookies and session variables.
    $_SESSION['step_log'] = FALSE;
    $_SESSION['data_pospago'] = FALSE;
    $_SESSION['security_question_0'] = FALSE;
    $_SESSION['security_question_1'] = FALSE;
    $_SESSION['security_question_2'] = FALSE;
    $_SESSION['security_question'] = FALSE;
    $_SESSION['identification_try'] = FALSE;
    $_SESSION['data_pospago'] = FALSE;
    $_SESSION['security_question_try'] = FALSE;
    user_cookie_delete('msisdn');
    user_cookie_delete('imsi');
    $store->delete('client_email');
    $store->delete('product_id');
    $store->delete('basket_id');
    $store->delete('date');
    $store->delete('id_document');
    $store->delete('id_type');
    $store->delete('real_msisdn');
    $store->delete('iccid');
    $store->delete('product_id_reference');
    $store->delete('reference_number');
    $store->delete('error');
    $store->delete('account_id_find');

    return $output;
  }
}
