<?php

namespace Drupal\transformation_activation\Controller;

use Symfony\Component\HttpFoundation\Response;
use Drupal\Core\Controller\ControllerBase;
use Drupal\Component\Serialization\Json;
use Drupal\transformation_activation\Activation;

class ReservationUpdate extends ControllerBase {

  /**
   * {@inheritdoc}
   */
  public function View() {
    \Drupal::service('page_cache_kill_switch')->trigger();
    $tempstore = \Drupal::service('tempstore.private');
    $config    = \Drupal::config('tigo_vtex_api.settings');
    $store = $tempstore->get('transformation_activation');
    $reserved_for = (NULL ==! $store->get('reserved_for'))
    ? $store->get('reserved_for') : '';
    $settings  = $config->get('tigo_act_settings');
    $real_msisdn = isset($_POST['number'])
    ? $_POST['number'] : FALSE;

    if ($real_msisdn !== FALSE) {

      // Storage.
      $data = [
        'basket_id' => (NULL ==! $store->get('basket_id'))
        ? $store->get('basket_id') : '',
        'account_id' => (NULL ==! $store->get('account_id_find'))
        ? $store->get('account_id_find') : '',
        'msisdn' => isset($_COOKIE['Drupal_visitor_msisdn'])
        ? $_COOKIE['Drupal_visitor_msisdn'] : '',
        'client_email' => (NULL ==! $store->get('client_email'))
        ? $store->get('client_email') : '',
        'reserved_for' => $reserved_for,
        'date' => (NULL ==! $store->get('date'))
        ? $store->get('date') : '',
        'real_msisdn' => $real_msisdn,
      ];

      if ($settings['options']['debug_mode'] != 1) {
        $activation = \Drupal::service('transformation.qvantel_services')->activation($data);
      }
      else {
        drupal_set_message("¡Se encuentra en modo debug.", "info");
      }

      if (isset($activation) && $activation == TRUE) {
        $logLog = [
          'step' => 3,
          'log' => 'Usuario selecciona numero',
          'data' => json_encode($data),
        ];
        $log_enconde = json_encode($logLog);

        Activation:: queryLogUpdate($data['client_email'], $data['date'], $log_enconde);
        \Drupal::logger('orders')->notice(print_r($data, 1));

        $response = [
          'send' => '/servicios-transformacion/activate/paso4',
        ];
      }
      else {
        $response = [
          'error' => '/servicios-transformacion/error-activacion',
        ];
      }

    }
    else {
      $response = [];
    }

    $params = Json::encode($response);
    $response = new Response();
    $response->setContent($params);
    $response->headers->set('Content-Type', 'application/json');
    $response->headers->set('Access-Control-Allow-Origin', '*');
    $value_return = $response;

    return $value_return;
  }

}
