<?php

namespace Drupal\transformation_activation\Controller;

//require $_SERVER['DOCUMENT_ROOT'] . "/vendor/setasign/eval/setapdf-signer/ioncube/php7.1/library/SetaPDF/Autoload.php";

use Drupal\Core\Controller\ControllerBase;
use Drupal\transformation_activation\GenerateXml;

//use SetaPDF_Core_Writer_File;
//use SetaPDF_Core_Document;
//use SetaPDF_Signer;
//use SetaPDF_Signer_Signature_Module_OpenSsl;

/**
 * Controller routines for page example routes.
 */
class TestBorrar extends ControllerBase
{
	/* Attributes */
	private $name_pdf = 'sites/default/files/test_1.pdf';
	private $seta_pdf = 'sites/default/files/seta.pdf';

	/**
	 * {@inheritdoc}
	 */
	protected function getModuleName()
	{
		return 'transformation_activation_tester';
	}


	/**
	 * Constructs a simple page.s
	 *
	 * The router _controller callback, maps the path
	 *
	 * _controller callbacks return a renderable array for the content area of the
	 * page. The theme system will later render and surround the content with the
	 * appropriate blocks, navigation, and styling.
	 */
	public function View()
	{
		/*$firma = drupal_get_path('module', 'transformation_activation').'/images/selfie_temporal.jpg';
		$foto = drupal_get_path('module', 'transformation_activation').'/images/selfie_temporal.jpg';
		$imagen_documento = drupal_get_path('module', 'transformation_activation').'/images/cedula_temporal.jpg';
		$date = format_date(time(), 'custom', 'd/m/Y H:i');
		$page1 = [
			'#theme' => 'tigo-activation-pdf-page-1',
			'#contrato' => 11111011111,
			'#fecha' => $date,
			'#msisdn' => 3123988989,
			'#fijo' => 7898989,
			'#movil_adicional' => 3122227889,
			'#barrio' => 'Ciudad Bolivar',
			'#nombre' => 'John Sanchez',
			'#documento' => 12288999,
			'#correo' => 'qolsoom@gmool.com',
			'#direccion' => 'Cll 67 # 78 - 23',
			'#municipio' => 'Bogotá Cundinamarca',
			'#referencias' => [
				[
					'nombre' => 'Ana Avila',
					'parentesco' => 'Hermana',
					'telefono' => 3126788979
				],
				[
					'nombre' => 'Jorge Ardilla',
					'parentesco' => 'Nieto',
					'telefono' => 3127889090
				]
			],
			'#contacto_autorizado' => [
				'nombres' => 'Julian Sarmiento',
				'tipo_documento' => 'CC',
				'numero_documento' => 102389999,
				'telefono' => 7868888,
				'celular' => 3126788899,
				'cod_postal' => 110111
			],
			'#firma' => $firma,
			'#foto' => $foto
		];

		$page2 = [
			'#theme' => 'tigo-activation-pdf-page-2',
			'#contrato' => 11111011111,
			'#fecha' => $date,
			'#msisdn' => 3123988989,
			'#fijo' => 7898989,
			'#movil_adicional' => 3122227889,
			'#barrio' => 'Ciudad Bolivar',
			'#nombre' => 'John Sanchez',
			'#documento' => 12288999,
			'#correo' => 'qolsoom@gmool.com',
			'#direccion' => 'Cll 67 # 78 - 23',
			'#municipio' => 'Bogotá Cundinamarca'
		];

		$page3 = [
			'#theme' => 'tigo-activation-pdf-page-3',
			'#contrato' => 11111011111,
			'#documento' => 12288999,
			'#firma' => $firma
		];

		$page4 = [
			'#theme' => 'tigo-activation-pdf-page-4',
			'#contrato' => 11111011111,
			'#msisdn' => 3123988989,
			'#nombre' => 'John Sanchez',
			'#documento' => 12288999,
			'#fecha' => $date,
			'#firma' => $firma,
			'#foto' => $foto
		];

		$page5 = [
			'#theme' => 'tigo-activation-pdf-page-5',
			'#contrato' => 11111011111,
			'#fecha' => $date,
			'#msisdn' => 3123988989,
			'#nombre' => 'John Sanchez',
			'#documento' => 12288999,
			'#firma' => $firma
		];

		$page6 = [
			'#theme' => 'tigo-activation-pdf-page-6',
			'#fecha' => $date,
			'#msisdn' => 3123988989,
			'#nombre' => 'John Sanchez',
			'#documento' => 12288999,
			'#firma' => $firma
		];

		$page7 = [
			'#theme' => 'tigo-activation-pdf-page-7',
			'#imagen_documento' => $imagen_documento,
		];

		$page1 = drupal_render($page1);
		$page2 = drupal_render($page2);
		$page3 = drupal_render($page3);
		$page4 = drupal_render($page4);
		$page5 = drupal_render($page5);
		$page6 = drupal_render($page6);
		$page7 = drupal_render($page7);




		$mpdf = new \Mpdf\Mpdf([
			'tempDir' => 'sites/default/files/tmp',
			'format' => 'Legal',
			'margin_top' => 8.2,
			'margin_left' => 7.1,
			'margin_right' => 2.4,
			'margin_bottom' => 8.2
		]);

		$stylesheet = file_get_contents(drupal_get_path('module', 'transformation_activation').'/css/pdf.css');
		$mpdf->WriteHTML($stylesheet, 1);
		$mpdf->WriteHTML($page1);
		$mpdf->AddPage();
		$mpdf->WriteHTML($page2);
		$mpdf->AddPage();
		$mpdf->WriteHTML($page3);
		$mpdf->AddPage();
		$mpdf->WriteHTML($page4);
		$mpdf->AddPage();
		$mpdf->WriteHTML($page5);
		$mpdf->AddPage();
		$mpdf->WriteHTML($page6);
		$mpdf->AddPage();
		$mpdf->WriteHTML($page7);
		$mpdf->Output($this->name_pdf, 'F');


		$document = SetaPDF_Core_Document::loadByFilename($this->name_pdf, new SetaPDF_Core_Writer_File($this->seta_pdf));

		$signer = new SetaPDF_Signer($document);

		// set some signature properties
		$signer->setReason('tigo');
		$signer->setLocation('www.tigo.com');
		$signer->setTimestampModule();

		$module = new SetaPDF_Signer_Signature_Module_OpenSsl();

		$certificate = '/etc/nginx/ssl/nginx.crt';

		$module->setCertificate(file_get_contents($certificate));

		$private = '/etc/nginx/ssl/nginx.key';

		$module->setPrivateKey(array(file_get_contents($private), ''));

		$signer->sign($module);*/

		$algo = new GenerateXml([
			'contrato' => 1234445555,
			'nombre' => 'Jorge Bolaños',
			'tipo_documento' => 'CC',
			'documento' => 899999999,
			'direccion' => 'Cll 59 c Sur No. 87h - 23',
			'barrio' => 'Bosa',
			'codigo_postal' => 110122,
			'fijo' => 7867889,
			'msisdn' => 3007898989,
			'correo' => "algo@algo.com",
			'ciudad' => 'Bogota',
			'departamento' => 'Cundinamarca',
			'movil_adicional' => 3007898989,
			'precio' => 49900,
			'nombre_plan' => "habla y no dejes de hablar"
		]);
		$algo->xml();

		/*$mailManager = \Drupal::service('plugin.manager.mail');
		$module = 'transformation_activation';
		$key = 'email_contract';
		$to = "aculma@seedem.co";

		global $base_url;
		$message = [
			'#theme' => 'tigo-activation-email',
			'#name' => "Andres",
			'#msisdn' => 3007898988,
			'#base_url' => $base_url,
		];

		$message = drupal_render($message);
		$stylesheet = file_get_contents(drupal_get_path('module', 'transformation_activation').'/css/email.css');

		$params['message'] = $message;
		$params['title'] = 'Contrato ';
		$langcode = \Drupal::currentUser()->getPreferredLangcode();
		// Attach pdf file to email params
		$file = new \stdClass();
		$file->filepath = '/tmp/300300300.pdf';
		$file->filename = '300300300.pdf';
		$file->filemime = 'application/pdf';
		$params['attachments'][] = $file;
		$params['css'] = $stylesheet;
		$result = $mailManager->mail($module, $key, $to, $langcode, $params, NULL, TRUE);
*/
		return [
			'#markup' => "hola mundo"
		];
	}

	public function imageTrimBox($img, $hex=null){
		if (!ctype_xdigit($hex)) $hex = imagecolorat($img, 0, 0);
		$b_top = $b_lft = 0;
		$b_rt = $w1 = $w2 = imagesx($img);
		$b_btm = $h1 = $h2 = imagesy($img);

		do {
			//top
			for(; $b_top < $h1; ++$b_top) {
				for($x = 0; $x < $w1; ++$x) {
					if(imagecolorat($img, $x, $b_top) != $hex) {
						break 2;
					}
				}
			}

			// stop if all pixels are trimmed
			if ($b_top == $b_btm) {
				$b_top = 0;
				$code = 2;
				break 1;
			}

			// bottom
			for(; $b_btm >= 0; --$b_btm) {
				for($x = 0; $x < $w1; ++$x) {
					if(imagecolorat($img, $x, $b_btm-1) != $hex) {
						break 2;
					}
				}
			}

			// left
			for(; $b_lft < $w1; ++$b_lft) {
				for($y = $b_top; $y <= $b_btm; ++$y) {
					if(imagecolorat($img, $b_lft, $y) != $hex) {
						break 2;
					}
				}
			}

			// right
			for(; $b_rt >= 0; --$b_rt) {
				for($y = $b_top; $y <= $b_btm; ++$y) {
					if(imagecolorat($img, $b_rt-1, $y) != $hex) {
						break 2;
					}
				}

			}

			$w2 = $b_rt - $b_lft;
			$h2 = $b_btm - $b_top;
			$code = ($w2 < $w1 || $h2 < $h1) ? 1 : 0;
		} while (0);

		// result codes:
		// 0 = Trim Zero Pixels
		// 1 = Trim Some Pixels
		// 2 = Trim All Pixels
		return array(
			'#'     => $code,   // result code
			'l'     => $b_lft,  // left
			't'     => $b_top,  // top
			'r'     => $b_rt,   // right
			'b'     => $b_btm,  // bottom
			'w'     => $w2,     // new width
			'h'     => $h2,     // new height
			'w1'    => $w1,     // original width
			'h1'    => $h1,     // original height
		);
  }

  public function myTest() {
    try {
      $client = \Drupal::httpClient();
      $response = $client->request('GET', 'http://httpbin.org/ip');
    }
    catch(\Exception $e) {
      $response = $e->getMessage();
    }
    \Drupal::logger('response')->notice(print_r($response, 1));

    return [
      '#markup' => 'test',
    ];
  }
}
