<?php

namespace Drupal\transformation_activation\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\transformation_activation\Activation;

class TransformationError extends ControllerBase {

  public function View() {
    $tempstore = \Drupal::service('tempstore.private');
    $store = $tempstore->get('transformation_activation');

    if (isset($_SESSION['error_expedition'])) {
      unset($_SESSION['error_expedition']);
    }

    // Storage.
    $data = [
      'basket_id' => (NULL ==! $store->get('basket_id'))
        ? $store->get('basket_id') : '',
      'product_id' => (NULL ==! $store->get('product_id'))
      ? $store->get('product_id') : '',
      'date' => (NULL ==! $store->get('date'))
        ? $store->get('date') : '',
      'client_email' =>(NULL ==! $store->get('client_email'))
        ? $store->get('client_email') : '',
      'document' => (NULL ==! $store->get('id_document'))
      ? $store->get('id_document') : '',
      'type' => (NULL ==! $store->get('id_type'))
      ? $store->get('id_type') : '',
    ];

    $logLog = [
      'step' => 2,
      'log' => 'Error al validar fecha de expedicion de la cedula',
      'data' => json_encode($data),
    ];
    $log_enconde = json_encode($logLog);
    Activation:: queryLogUpdate($data['client_email'], $data['date'], $log_enconde);
    \Drupal::logger('orders')->notice(print_r($data, 1));

    return [
        '#theme' => 'transformation-activation-error',
        '#attached' => array(
          'library' => array(
            'transformation_activation/transformation_activation',
          ),
        ),
    ];
  }
}
