<?php

namespace Drupal\transformation_activation\Controller;

use Symfony\Component\HttpFoundation\Response;
use Drupal\Core\Controller\ControllerBase;
use Drupal\Component\Serialization\Json;

/**
 * Controller routines for validate capcha.
 */
class ValidateCapchaActivation extends ControllerBase {

  /**
   * {@inheritdoc}
   */
  public function Capcha() {
    $uri = 'private://ActivationValidate.txt';
    $flag = FALSE;
    $file = fopen($uri, "r") or exit("Unable to open file!");
    // Output a line of the file until the end is reached.
    while ($linea = fgets($file)) {
      if (trim($linea) == $_POST['token']) {
        $_SESSION['activation_token'] = $_POST['token'];
        $flag = TRUE;
      }
    }
    fclose($file);

    if (isset($_POST['email']) && $flag) {
      $activation_s = \Drupal::service('transformation.qvantel_services');
      $activation = TRUE;
      $email = $_POST['email'];
      try {
        $account_id = $activation_s->validateCer($email, 'TI');
      }
      catch (\Exception $e) {
        $account_id['error'] = $e->getMessage();
        $account_id['code'] = $e->getCode();
      }
      if (!is_array($account_id) && !empty($account_id) && $account_id == TRUE) {
        try {
          $data = $activation_s->getUserDataByAccount($account_id);
        }
        catch (\Exception $e) {
          $data['error'] = $e->getMessage();
          $data['code'] = $e->getCode();
        }
        if (isset($data['id_document']) && !empty($data['id_document']) && isset($data['id_type']) && !empty($data['id_type'])) {
          try {
            $account_exist = $activation_s->getOrders('exist_account', $data['id_document'], $data['id_type']);
            if (!empty($account_exist) && $account_exist == TRUE) {
              $date = date('Y-m-d H:i:s');
              $log = [
                0 => [
                  'step' => 1,
                  'log' => 'Se valido el correo contra Vtex',
                ],
              ];
              $log_enconde = json_encode($log);


              $tempstore = \Drupal::service('tempstore.private');
              $store = $tempstore->get('transformation_activation');
              // Set the key/value pair.
              $store->set('account_id', $account_id);
              $store->set('client_email', $email);
              $store->set('date', $date);
              $store->set('id_document', $data['id_document']);
              $store->set('id_type', $data['id_type']);

              user_cookie_save([
                'account_id'   => $account_id,
                'client_email' => $email,
                'date'         => $date,
                'id_document'  => $data['id_document'],
                'id_type'      => $data['id_type'],
              ]);

              $response = [
                'send' => '/servicios-transformacion/activate/paso1',
              ];
            }
            else {
              $response = [
                'error' => 'Actualmente no existen productos asociados a esta cuenta',
              ];
            }
          }
          catch (\Exception $e) {
            $account_exist['error'] = $e->getMessage();
            $account_exist['code'] = $e->getCode();
          }
        }
      }
      else {
        $response = [
          'error' => 'El correo ingresado no es el mismo registrado en tu compra. Por favor verifica la información',
        ];
      }
    }
    else {
      $response = [];
    }

    $params = Json::encode($response);
    $response = new Response();
    $response->setContent($params);
    $response->headers->set('Content-Type', 'application/json');
    $response->headers->set('Access-Control-Allow-Origin', '*');
    $value_return = $response;

    return $value_return;
  }

  /**
   * {@inheritdoc}
   */
  public function singular($num, $type) {
    switch ($type) {
      case 'minutos':
        $return = $num == 1 ? $num . ' minuto ' : $num . ' minutos ';
        break;

      default:
        $return = '';
        break;
    }

    return $return;
  }

}
