<?php
/**
 * @file
 * Contains \Drupal\transformation_activation\Form\ActivateSim.
 */
namespace Drupal\transformation_activation\Form;

use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Form\FormBase;


class Anexos extends FormBase {

    public function getFormId() {
        return 'transformation_activation_anexos';
    }


    public function buildForm(array $form, FormStateInterface $form_state)
    {
        $form['renovacion'] = [
            '#type' => 'radios',
            '#title' => 'Acepto que mi contrato se renueve sucesiva y automaticamente por un plazo igual al inicial.',
            '#default_value' => 1,
            '#options' => [
                1 => 'Si',
                0 => 'No'
            ]
        ];
        $form['disposicion'] = [
            '#type' => 'radios',
            '#title' => 'Desea Usted, recibir la información por medio electronico.',
            '#default_value' => 1,
            '#options' => [
                1 => 'Si',
                0 => 'No'
            ]
        ];
        $form['factura_electronica'] = [
            '#type' => 'checkbox',
            '#title' => 'Acepto recibir facturas solamente por medios electrónicos',
            '#default_value' => 1
        ];
        $form['disposiciones_legales'] = [
            '#type' => 'checkbox',
            '#title' => 'Acepto anexo de disposiciones legales',
            '#required' => true,
            '#default_value' => 1,
            '#attributes' => [
                'class' => ['anexo-check']
            ]
        ];
        $form['container'] = [
            '#type' => 'container',
            '#attributes' => [
                'class' => 'anexos'
            ],
            '#tree' => TRUE
        ];
        $form['container']['anexo_1'] = [
            '#type' => 'checkbox',
            '#title' => 'Acepto el contrato único de servicios móviles pospago',
            '#required' => true,
            '#default_value' => 1,
            '#attributes' => [
                'class' => ['anexo-check']
            ]
        ]; 
        $form['container']['anexo_2'] = [
            '#type' => 'checkbox',
            '#title' => 'Acepto las condiciones comerciales del plan adquirido',
            '#required' => true,
            '#default_value' => 1,
            '#attributes' => [
                'class' => ['anexo-check']
            ]
        ];
    
        $form['submit'] = [
            '#type' => 'submit',
            '#value' => 'Continuar',
            '#attributes' => [
                'class' => [
                    'buttonform'
                ]
            ]
        ];
        return $form;
    }

    public function submitForm(array &$form, FormStateInterface $form_state) {
        $data = $_SESSION['data_pospago'];
        $data['moreData']['anexos'] = [
            'renovacion' => $form_state->getValue('renovacion'),
            'disposicion' => $form_state->getValue('disposicion'),
            'factura_electronica' => $form_state->getValue('factura_electronica')
        ];
        $_SESSION['data_pospago'] = $data;
        $form_state->setRedirect('transformation_activation.contrato');
    }
}
