<?php
/**
 * @file
 * Contains \Drupal\transformation_activation\Form\ActivateSim.
 */
namespace Drupal\transformation_activation\Form;

use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Form\FormBase;

class CodesActivation extends FormBase
{

    public function getFormId() {
        return 'tigo_codes_activation';
    }


    public function buildForm(array $form, FormStateInterface $form_state) {
        $config = \Drupal::config('transformation_activation.settings');
        $codes = $config->get('codes');

        $form['#tree'] = TRUE;

        $form['codes'] = [
            '#type' => 'container',
            '#attributes' => array(
                'class' => 'accommodation',
            ),
            '#states' => array(
                'invisible' => array(
                    'input[name="needs_accommodation"]' => array(
                        'checked' => FALSE,
                    ),
                ),
            ),
            '#prefix' => '<hr>'
        ];
        $num = 0;
        if(!empty($codes['code_' . $num])){

            foreach ($codes as $key => $value){
                if(!empty($codes['code_' . $num]['code']) && !empty($codes['code_' . $num]['message'])){
                    $form = $this->moreCodes($form, $codes, $num);
                    $num += 1;
                }
            }
            $form = $this->moreCodes($form, $codes, $num);

        }else{
            $form = $this->moreCodes($form, $codes, $num);
        }
        $form['save'] = [
            '#type' => 'submit',
            '#value' => $this->t('Save'),
        ];
        return $form;
    }

    public function moreCodes($form, $codes, $num){
        $form['codes']['code_' . $num] = [
            '#type' => 'container',
            '#attributes' => array(
                'class' => 'accommodation',
            ),
            '#states' => array(
                'invisible' => array(
                    'input[name="needs_accommodation"]' => array(
                        'checked' => FALSE,
                    ),
                ),
            ),
            '#prefix' => '<hr>'
        ];
        $form['codes']['code_' . $num]['code'] = [
            '#type' => 'number',
            '#title' => $this->t('Codigo'),
            '#default_value' => isset($codes['code_' . $num]['code'])
                ? $codes['code_' . $num]['code']
                : FALSE
        ];
        $form['codes']['code_' . $num]['message'] = [
            '#type' => 'textfield',
            '#title' => $this->t('Mensaje'),
            '#default_value' => isset($codes['code_' . $num]['message'])
                ? $codes['code_' . $num]['message']
                : FALSE
        ];
        return $form;
    }

    public function submitForm(array &$form, FormStateInterface $form_state) {
        $config = \Drupal::service('config.factory')->getEditable('transformation_activation.settings');
        $config->set('codes', $form_state->getValue('codes'));
        $config->save();
    }

    public function validateForm(array &$form, FormStateInterface $form_state) {

    }
}
