<?php

namespace Drupal\transformation_activation\Form;

use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Defines a form that configures forms module settings.
 */
class SecurityQuestionDelete extends FormBase {

	/**
	 * {@inheritdoc}
	 */
	public function getFormId() {
		return 'transformation_activation_security_question_delete';
	}


	/**
	 * {@inheritdoc}
	 */
	public function buildForm(array $form, FormStateInterface $form_state, $id = NULL)
	{
		$query = db_select('transformation_activation_security_questions', 'sc');
		$query->addField('sc', 'question');
		$query->condition('sc.id', $id, '=');
		$result = $query->execute()->fetchObject();
		if($result){
			$form['id'] = [
				'#type' => 'hidden',
				'#value' => $id
			];

			$form['markup'] = [
				'#type' => 'markup',
				'#markup' => 'Esta seguro que desea eliminar ' . $result->question . '<br>'
			];
			$form['submit'] = [
				'#type' => 'submit',
				'#value' => 'Eliminar',
			];
		}
		return $form;
	}



	/**
	 * {@inheritdoc}
	 */
	public function validateForm(array &$form, FormStateInterface $form_state) {
	}

	/**
	 * {@inheritdoc}
	 */
	public function submitForm(array &$form, FormStateInterface $form_state) {
		$id = $form_state->getValue('id');
		$connection = \Drupal::database();
		$connection->delete('transformation_activation_security_questions')
			->condition('id', $id)
			->execute();
		drupal_set_message('Se ha eliminado el dato exitosamente', 'info');
		$form_state->setRedirect('transformation_activation_admin.security_questions');
	}
}
