<?php

namespace Drupal\transformation_activation\Form;

use Symfony\Component\HttpFoundation\Request;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Url;
use Drupal\Core\Form\FormBase;

/**
 * Defines a form that configures forms module settings.
 */
class SecurityQuestions extends FormBase {

	/**
	* {@inheritdoc}
	*/
	public function getFormId() {
		return 'transformation_activation_security_questions';
	}


	/**
	* {@inheritdoc}
	*/
	public function buildForm(array $form, FormStateInterface $form_state, Request $request = NULL) 
	{
		$header = [
			'question' => 'Pregunta',
			'options' => 'Opciones'
		];
		$output = $this->creationTable();
		$form['container_table'] = [
			'#type' => 'container',
			'#attributes' => [
				'id' => 'paquetes-vtex-tabla'
			]
		];
		$form['container_table']['table'] = [
			'#type' => 'table',
			'#header' => $header,
			'#attributes' => ['class' => ['paquetes-table']],
			'#rows' => $output,
			'#empty' => 'No se encontro información',
		];

		$form['container_table']['pager'] = array(
			'#type' => 'pager'
		);


		$form['add'] = [
			'#type' => 'link',
			'#title' => $this->t('Agregar'),
			'#url' => Url::fromRoute(
				'transformation_activation_admin.security_questions_add'
			),

		];
		return $form;
	}

	public function creationTable(){
		$query = db_select('transformation_activation_security_questions', 'sc');
		$query->addField('sc', 'id');
		$query->addField('sc', 'question');
		$pager = $query->extend('Drupal\Core\Database\Query\PagerSelectExtender')->limit(10);
		$results = $pager->execute();
		$output = [];
		foreach ($results as $value){
			$option = [
				0 => [
					'#type' => 'link',
					'#title' => 'Editar',
					'#url' => Url::fromRoute(
						'transformation_activation_admin.security_questions_edit',
						[
							'id' => $value->id
						]
					)
				],
				1 => [
					'#type' => 'link',
					'#title' => 'Eliminar',
					'#url' => Url::fromRoute(
						'transformation_activation_admin.security_questions_delete',
						[
							'id' => $value->id
						]
					)
				]
			];

			$link = [
				'#theme' => 'item_list',
				'#items' => $option
			];
			$output[$value->id] = [
				'question' => $value->question,
				'options' =>  [
					'data' => $link
				]
			];
		}
		return $output;
	}

	/**
	* {@inheritdoc}
	*/
	public function validateForm(array &$form, FormStateInterface $form_state) {
	}

	/**
	* {@inheritdoc}
	*/
	public function submitForm(array &$form, FormStateInterface $form_state) {

	}
}
