<?php
/**
 * Created by PhpStorm.
 * User: andres
 * Date: 17/07/18
 * Time: 09:27 AM
 */

namespace Drupal\transformation_activation;

require $_SERVER['DOCUMENT_ROOT'] . "/vendor/dsiddharth2/php-zxing/src/PHPZxing/PHPZxingBase.php";
require $_SERVER['DOCUMENT_ROOT'] . "/vendor/dsiddharth2/php-zxing/src/PHPZxing/PHPZxingInterface.php";
require $_SERVER['DOCUMENT_ROOT'] . "/vendor/dsiddharth2/php-zxing/src/PHPZxing/PHPZxingDecoder.php";
require $_SERVER['DOCUMENT_ROOT'] . "/vendor/dsiddharth2/php-zxing/src/PHPZxing/ZxingImage.php";
require $_SERVER['DOCUMENT_ROOT'] . "/vendor/dsiddharth2/php-zxing/src/PHPZxing/ZxingBarNotFound.php";

use PHPZxing\PHPZxingDecoder;
use Drupal\Core\Render\Markup;


class GeneratePdf
{
	/* Attributes */
	private $contrato;
	private $fecha;
	private $fecha_inicio;
	private $fecha_corte;
	private $name_pdf;
	private $msisdn;
	private $nombre_plan;
	private $fijo;
	private $movil_adicional;
	private $barrio;
	private $nombre;
	private $documento;
	private $correo;
	private $direccion;
	private $departamento;
	private $ciudad;
	private $municipio;
	private $precio;
	private $referencias;
	private $contacto_autorizado;
	private $detalles;
	private $firma;
	private $foto;
	private $imagen_documento_1;
	private $imagen_documento_2;
	private $renovacion;
	private $disposicion;
	private $factura_electronica;

	public function __construct($data) {
		$this->contrato = !empty($data['contrato'])
			? $data['contrato']
			: FALSE;
		$this->fecha = format_date(time(), 'custom', 'd/m/Y H:i');
		$fecha_inicio = strtotime('+1 day', time());
		$this->fecha_inicio = format_date($fecha_inicio, 'custom', 'd/m/Y');
		$this->fecha_corte = format_date($fecha_inicio, 'custom', 'd');
		$this->name_pdf = file_directory_temp() . '/'. $this->contrato .'.pdf';
		$this->msisdn = !empty($data['msisdn'])
			? $data['msisdn']
			: FALSE;
		$this->nombre_plan = !empty($data['nombre_plan'])
			? $data['nombre_plan']
			: FALSE;
		$this->fijo = !empty($data['fijo'])
			? $data['fijo']
			: FALSE;
		$this->movil_adicional = !empty($data['movil_adicional'])
			? $data['movil_adicional']
			: FALSE;
		$this->barrio = !empty($data['barrio'])
			? $data['barrio']
			: FALSE;
		$this->nombre = !empty($data['nombre'])
			? $data['nombre']
			: FALSE;
		$this->documento = !empty($data['documento'])
			? $data['documento']
			: FALSE;
		$this->correo = !empty($data['correo'])
			? $data['correo']
			: FALSE;
		$this->direccion = !empty($data['direccion'])
			? $data['direccion']
			: FALSE;
		$this->departamento = !empty($data['departamento'])
			? $data['departamento']
			: FALSE;
		$this->ciudad = !empty($data['ciudad'])
			? $data['ciudad']
			: FALSE;
		$this->municipio = $this->ciudad . ' ' . $this->departamento;
		$this->precio = !empty($data['precio'])
			? number_format($data['precio'], 0, '', '.')
			: FALSE;
		$this->referencias = isset($data['referencias'])
			? array_values($data['referencias'])
			: FALSE;
		$this->contacto_autorizado = isset($data['contacto_autorizado'])
			? $data['contacto_autorizado']
			: FALSE;
		$this->detalles = isset($data['detalles'])
			? $data['detalles']
			: FALSE;
		$this->firma =  !empty($data['firma'])
			? $data['firma']
			: FALSE;
		$this->foto = !empty($data['foto'])
			? $data['foto']
			: FALSE;
		$this->imagen_documento_1 = !empty($data['imagen_documento_1'])
			? $data['imagen_documento_1']
			: FALSE;
		$this->imagen_documento_2 = !empty($data['imagen_documento_2'])
			? $data['imagen_documento_2']
			: FALSE;
		$this->validar_firma = !empty($data['validar_firma'])
			? $data['validar_firma']
			: FALSE;
		$this->renovacion = !empty($data['renovacion'])
			? 'Si'
			: 'No';
		$this->disposicion = !empty($data['disposicion'])
			? 'Si'
			: 'No';
		$this->factura_electronica = !empty($data['factura_electronica'])
			? $data['factura_electronica']
			: FALSE;
	}

	public function pdf(){
		$page1 = [
			'#theme' => 'tigo-activation-pdf-page-1',
			'#contrato' => $this->contrato,
			'#fecha' => $this->fecha,
			'#msisdn' => $this->msisdn,
			'#fijo' => $this->fijo,
			'#movil_adicional' => $this->movil_adicional,
			'#barrio' => $this->barrio,
			'#nombre' => $this->nombre,
			'#documento' => $this->documento,
			'#correo' => $this->correo,
			'#direccion' => $this->direccion,
			'#municipio' => $this->municipio,
			'#referencias' => $this->referencias,
			'#contacto_autorizado' => $this->contacto_autorizado,
			'#firma' => $this->firma,
			'#foto' => $this->foto
		];

		$page2 = [
			'#theme' => 'tigo-activation-pdf-page-2',
			'#contrato' => $this->contrato,
			'#fecha' => $this->fecha,
			'#fecha_inicio' => $this->fecha_inicio,
			'#msisdn' => $this->msisdn,
			'#fijo' => $this->fijo,
			'#movil_adicional' => $this->movil_adicional,
			'#barrio' => $this->barrio,
			'#nombre' => $this->nombre,
			'#documento' => $this->documento,
			'#correo' => $this->correo,
			'#direccion' => $this->direccion,
			'#municipio' => $this->municipio,
			'#detalles' => $this->detalles,
			'#precio' => $this->precio,
			'#renovacion' => $this->renovacion,
			'#fecha_corte' => $this->fecha_corte
		];

		$page3 = [
			'#theme' => 'tigo-activation-pdf-page-3',
			'#contrato' => $this->contrato,
			'#documento' => $this->documento,
			'#firma' => $this->firma,
			'#factura_electronica' => $this->factura_electronica
		];

		$page4 = [
			'#theme' => 'tigo-activation-pdf-page-4',
			'#contrato' => $this->contrato,
			'#msisdn' => $this->msisdn,
			'#nombre' => $this->nombre,
			'#documento' => $this->documento,
			'#fecha' => $this->fecha,
			'#firma' => $this->firma,
			'#foto' => $this->foto,
			'#disposicion' => $this->disposicion
		];

		$page5 = [
			'#theme' => 'tigo-activation-pdf-page-5',
			'#contrato' => $this->contrato,
			'#fecha' => $this->fecha,
			'#msisdn' => $this->msisdn,
			'#nombre' => $this->nombre,
			'#documento' => $this->documento,
			'#firma' => $this->firma,
			'#nombre_plan' => $this->nombre_plan,
			'#precio' => $this->precio
		];

		$page7 = [
			'#theme' => 'tigo-activation-pdf-page-7',
			'#imagen_documento_1' => $this->imagen_documento_1,
			'#imagen_documento_2' => $this->imagen_documento_2,
		];

		$page1 = drupal_render($page1);
		$page2 = drupal_render($page2);
		$page3 = drupal_render($page3);
		$page4 = drupal_render($page4);
		$page5 = drupal_render($page5);
		$page7 = drupal_render($page7);
		
		$mpdf = new \Mpdf\Mpdf([
			'tempDir' => 'sites/default/files/tmp',
			'format' => 'Legal',
			'margin_top' => 8,
			'margin_left' => 7,
			'margin_right' => 2,
			'margin_bottom' => 8
		]);

		$stylesheet = file_get_contents(drupal_get_path('module', 'transformation_activation').'/css/pdf.css');
		$mpdf->WriteHTML($stylesheet, 1);
		$mpdf->WriteHTML($page1);
		$mpdf->AddPage();
		$mpdf->WriteHTML($page2);
		$mpdf->AddPage();
		$mpdf->WriteHTML($page3);
		$mpdf->AddPage();
		$mpdf->WriteHTML($page4);
		$mpdf->AddPage();
		$mpdf->WriteHTML($page5);
		$mpdf->AddPage();
		$mpdf->WriteHTML($page7);
		$mpdf->Output($this->name_pdf, 'F');
	}

	public function ClearSign($img){
		$img = imagecreatefrompng($img);
		// find the trimmed image border
		$box = $this->imageTrimBox($img);

		// copy cropped portion
		$img2 = imagecreate($box['w'], $box['h']);
		imagecopy($img2, $img, 0, 0, $box['l'], $box['t'], $box['w'], $box['h']);

		// output cropped image to the browser

		ob_start();

		imagepng($img2);

		$str_img = ob_get_contents();
		imagedestroy($img);
		imagedestroy($img2);

		ob_end_clean();

		return $str_img;

		//return "data:image/png;base64," . base64_encode($str_img);
	}

	public function rotateImage($img){
		$origen = imagecreatefromjpeg($img);
		$rotar = imagerotate($origen, 90, 0);

		ob_start();

		imagejpeg($rotar);

		$str_img = ob_get_contents();

		imagedestroy($origen);
		imagedestroy($rotar);

		ob_end_clean();


		$save_image = file_save_data($str_img, 'temporary://' . session_id() . '_ide_back.jpg', FILE_EXISTS_REPLACE);
		$uri = $save_image->getFileUri();

		$path = str_replace('temporary://', file_directory_temp() . '/', $uri);

		return $path;

	}

	public function validateQrIdentification()
	{
		$img1 = imagecreatefromjpeg($this->imagen_documento_2);

		ob_start();

		imagejpeg($img1);

		$str_img = ob_get_contents();

		imagedestroy($img1);

		ob_end_clean();


		$save_image = file_save_data($str_img, 'temporary://' . session_id() . '_ide_back.jpg', FILE_EXISTS_REPLACE);
		$uri = $save_image->getFileUri();

		$config = \Drupal::config('tigo_vtex_api.settings');
		$tigo_act_settings = $config->get('tigo_act_settings');

		$foto = str_replace('temporary://', file_directory_temp() . '/', $uri);
		if(isset($tigo_act_settings['options']['debug_identification'])
			&& $tigo_act_settings['options']['debug_identification']){
			$_SESSION['path_identification_back'] = $foto;
			$return['send'] = TRUE;
		}else{
			$config = array(
				'try_harder' => true,
				'multiple_bar_codes' => true,
				// 'crop' => true
			);

			$decoder = new PHPZxingDecoder($config);
			$decodedArray = $decoder->decode($foto);

			$qr_value = FALSE;
			if(method_exists($decodedArray, 'getImageValue')){
				$qr_value = $decodedArray->getImageValue();
			}else{

				$foto = $this->rotateImage($foto);
				$decodedArray = $decoder->decode($foto);
				if(method_exists($decodedArray, 'getImageValue')){
					$qr_value = $decodedArray->getImageValue();
				}
			}
			$_SESSION['path_identification_back'] = $foto;
			$return['send'] = TRUE;
			if($qr_value){
				if(!preg_match("/".$this->documento."/m", $qr_value)){
					$return['error'] = Markup::create(
						'<span class="err_contract" data-error="3"><b>Paso 3:</b></span> La cédula escaneada no corrresponde con la registrada al momento de la compra. Por favor escanea de nuevo la cédula correspondiente.'
					);
				}
			}else{
				$return['error'] = Markup::create(
					'<span class="err_contract" data-error="3"><b>Paso 3:</b></span> La foto de tu cédula es borrosa y no podemos identificar tus datos. Por favor escanéala de nuevo'
				);
			}
		}
		return $return;
	}

	public function validateSign(){
		$img = imagecreatefrompng($this->validar_firma);
		// find the trimmed image border
		$box = $this->imageTrimBox($img);

		if($box['l'] == 0 || $box['t'] == 0){
			return FALSE;
		}

		return TRUE;
	}

	public function imageTrimBox($img, $hex=null){
		if (!ctype_xdigit($hex)) $hex = imagecolorat($img, 0, 0);
		$b_top = $b_lft = 0;
		$b_rt = $w1 = $w2 = imagesx($img);
		$b_btm = $h1 = $h2 = imagesy($img);

		do {
			//top
			for(; $b_top < $h1; ++$b_top) {
				for($x = 0; $x < $w1; ++$x) {
					if(imagecolorat($img, $x, $b_top) != $hex) {
						break 2;
					}
				}
			}

			// stop if all pixels are trimmed
			if ($b_top == $b_btm) {
				$b_top = 0;
				$code = 2;
				break 1;
			}

			// bottom
			for(; $b_btm >= 0; --$b_btm) {
				for($x = 0; $x < $w1; ++$x) {
					if(imagecolorat($img, $x, $b_btm-1) != $hex) {
						break 2;
					}
				}
			}

			// left
			for(; $b_lft < $w1; ++$b_lft) {
				for($y = $b_top; $y <= $b_btm; ++$y) {
					if(imagecolorat($img, $b_lft, $y) != $hex) {
						break 2;
					}
				}
			}

			// right
			for(; $b_rt >= 0; --$b_rt) {
				for($y = $b_top; $y <= $b_btm; ++$y) {
					if(imagecolorat($img, $b_rt-1, $y) != $hex) {
						break 2;
					}
				}

			}

			$w2 = $b_rt - $b_lft;
			$h2 = $b_btm - $b_top;
			$code = ($w2 < $w1 || $h2 < $h1) ? 1 : 0;
		} while (0);

		// result codes:
		// 0 = Trim Zero Pixels
		// 1 = Trim Some Pixels
		// 2 = Trim All Pixels
		return array(
			'#'     => $code,   // result code
			'l'     => $b_lft,  // left
			't'     => $b_top,  // top
			'r'     => $b_rt,   // right
			'b'     => $b_btm,  // bottom
			'w'     => $w2,     // new width
			'h'     => $h2,     // new height
			'w1'    => $w1,     // original width
			'h1'    => $h1,     // original height
		);
	}
}
