<?php
/**
 * Created by PhpStorm.
 * User: andres
 * Date: 17/07/18
 * Time: 09:27 AM
 */

namespace Drupal\transformation_activation;

class GenerateXml
{
	/* Attributes */
	private $contrato;
	private $fecha;
	private $fecha_inicio;
	private $fecha_corte;
	private $codigo_pos;
	private $seller_id;
	private $name_xml;
	private $msisdn;
	private $nombre_plan;
	private $fijo;
	private $movil_adicional;
	private $barrio;
	private $codigo_postal;
	private $nombre;
	private $documento;
	private $correo;
	private $direccion;
	private $departamento;
	private $ciudad;
	private $precio;
	private $detalles;
	private $renovacion;
	private $disposicion;

	public function __construct($data) {
		$this->contrato = !empty($data['contrato'])
			? $data['contrato']
			: FALSE;
		$this->fecha = format_date(time(), 'custom', 'd/m/Y H:i');
		$fecha_inicio = strtotime('+1 day', time());
		$this->fecha_inicio = format_date($fecha_inicio, 'custom', 'd/m/Y');
		$this->fecha_corte = format_date($fecha_inicio, 'custom', 'd');
		$config = \Drupal::config('tigo_vtex_api.settings');
		$settings = $config->get('tigo_act_settings');
		$this->codigo_pos = isset($settings['service']['codigo_pos']) 
			? $settings['service']['codigo_pos']
			: NULL;
		$this->seller_id = isset($settings['service']['sellerid']) 
			? $settings['service']['sellerid']
		  : '1019083585';
		$this->name_xml = file_directory_temp() . '/'. $this->contrato .'.xml';
		$this->msisdn = !empty($data['msisdn'])
			? $data['msisdn']
			: FALSE;
		$this->nombre_plan = !empty($data['nombre_plan'])
			? $data['nombre_plan']
			: FALSE;
		$this->fijo = !empty($data['fijo'])
			? $data['fijo']
			: FALSE;
		$this->movil_adicional = !empty($data['movil_adicional'])
			? $data['movil_adicional']
			: FALSE;
		$this->barrio = !empty($data['barrio'])
			? $data['barrio']
			: FALSE;
		$this->codigo_portal = !empty($data['codigo_portal'])
			? $data['codigo_portal']
			: FALSE;
		$this->nombre = !empty($data['nombre'])
			? $data['nombre']
			: FALSE;
		$this->documento = !empty($data['documento'])
			? $data['documento']
			: FALSE;
		$this->tipo_documento = !empty($data['tipo_documento'])
			? $data['tipo_documento']
			: FALSE;
		$this->correo = !empty($data['correo'])
			? $data['correo']
			: FALSE;
		$this->direccion = !empty($data['direccion'])
			? $data['direccion']
			: FALSE;
		$this->departamento = !empty($data['departamento'])
			? $data['departamento']
			: FALSE;
		$this->ciudad = !empty($data['ciudad'])
			? $data['ciudad']
			: FALSE;
		$this->precio = !empty($data['precio'])
			? number_format($data['precio'], 0, '', '.')
			: FALSE;
		$this->detalles = isset($data['detalles'])
			? $data['detalles']
			: FALSE;
		$this->renovacion = !empty($data['renovacion'])
			? 'Si'
			: 'No';
		$this->disposicion = !empty($data['disposicion'])
			? 'Si'
			: 'No';
	}

	public function xml(){
		$doc = new \DOMDocument('1.0', 'utf-8');
		$doc->formatOutput = true;

		$message = $doc->createElement('Message');
		$message = $doc->appendChild($message);

		$document = $doc->createElement('document');
		$document = $message->appendChild($document);

		$items = $doc->createElement('items');
		$items = $document->appendChild($items);

		$doc = $this->item($doc, $items, [
			'key' => 'fecha',
			'value' => $this->fecha,
			'type' => 'todayText',
			'label' => 'Fecha:'
		]);
		$doc = $this->item($doc, $items, [
			'key' => 'codigoPos',
			'value' => $this->codigo_pos,
			'type' => 'number',
			'label' => 'Código POS Tienda:'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'numeroDocumentoVendedor',
			'value' => $this->seller_id,
			'type' => 'number',
			'label' => 'Documento Vendedor:'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'nombres',
			'value' => $this->nombre,
			'type' => 'text',
			'label' => 'Nombre y Apellidos / Razón social'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'tipoPersona',
			'value' => 'Natural',
			'type' => 'select',
			'label' => 'Tipo Persona'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'tipoDocumento',
			'value' => $this->tipo_documento,
			'type' => 'select',
			'label' => 'Tipo Documento'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'numeroDocumento',
			'value' => $this->documento,
			'type' => 'number',
			'label' => 'Número Documento'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'direccion',
			'value' => $this->direccion,
			'type' => 'text',
			'label' => 'Dirección Domicilio'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'barrio',
			'value' => $this->barrio,
			'type' => 'text',
			'label' => 'Barrio Domicilio'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'codPostal',
			'value' => $this->codigo_portal,
			'type' => 'number',
			'label' => 'Código Postal'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'telefonoFijo',
			'value' => $this->fijo,
			'type' => 'tel',
			'label' => 'Teléfono Fijo'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'telefonoMovil',
			'value' => $this->movil_adicional,
			'type' => 'tel',
			'label' => 'Teléfono Móvil'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'mail',
			'value' => $this->correo,
			'type' => 'text',
			'label' => 'Correo Electrónico'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'emailRepeat',
			'value' => $this->correo,
			'type' => 'text',
			'label' => 'Correo Electrónico'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'departamento',
			'value' => $this->departamento,
			'type' => 'select',
			'label' => 'Departamento'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'ciudad',
			'value' => $this->ciudad,
			'type' => 'select',
			'label' => 'Ciudad'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'tipoTransaccion',
			'value' => "Activación Linea - Migración a Control",
			'type' => 'select',
			'label' => 'Tipo Transacción'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'movil',
			'value' => $this->msisdn,
			'type' => 'tel',
			'label' => 'Número Línea'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'imsi',
			'value' => $this->contrato,
			'type' => 'tel',
			'label' => 'Imsi'
		]);

		/* TODO */
		$doc = $this->item($doc, $items, [
			'key' => 'entregaContrato',
			'value' => $this->disposicion,
			'type' => 'radio',
			'label' => 'Desea recibir información del servicio por medio electrónico?'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'vigencia',
			'value' => 12,
			'type' => 'select',
			'label' => 'Vigencia del Contrato'
		]);

		/* TODO */
		$doc = $this->item($doc, $items, [
			'key' => 'renovacion',
			'value' => $this->renovacion,
			'type' => 'select',
			'label' => 'Acepto que mi contrato se renueve sucesiva y automáticamente por un plazo igual al inicial'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'telefonia',
			'value' => "SI",
			'type' => 'select',
			'label' => 'Telefonía?'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'internet',
			'value' => "SI",
			'type' => 'select',
			'label' => 'Internet?'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'sms',
			'value' => "SI",
			'type' => 'select',
			'label' => 'SMS?'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'otros',
			'value' => "",
			'type' => 'text',
			'label' => 'Otros?'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'fechaActivacion',
			'value' => $this->fecha_inicio,
			'type' => 'todayText',
			'label' => 'Fecha Máxima de Activacion'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'diaCanc',
			'value' => $this->fecha_corte,
			'type' => 'select',
			'label' => 'Dia de Corte:'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'planSeleccionado',
			'value' => $this->precio . ' - ' . $this->nombre_plan,
			'type' => 'select',
			'label' => 'Plan Seleccionado'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'descripcion',
			'value' => $this->precio . ' - Combo ATP',
			'type' => 'select',
			'label' => 'Tipo ATP'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'valorMinimo',
			'value' => $this->precio,
			'type' => 'select',
			'label' => 'Valor Plan'
		]);

		/* TODO */
		$doc = $this->item($doc, $items, [
			'key' => 'vozTD',
			'value' => "",
			'type' => 'select',
			'label' => 'Seleccione Paquete Voz Todo Destino'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'valorVozTD',
			'value' => "",
			'type' => 'select',
			'label' => 'Seleccione Valor (Si Aplica)'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'vozTigo',
			'value' => "",
			'type' => 'select',
			'label' => 'Seleccione Paquete Voz Tigo'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'valorVozTigo',
			'value' => "",
			'type' => 'select',
			'label' => 'Seleccione Valor (Si Aplica)'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'vozLDI',
			'value' => "",
			'type' => 'select',
			'label' => 'Seleccione Paquete Voz LDI'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'valorVozLDI',
			'value' => "",
			'type' => 'select',
			'label' => 'Seleccione Valor (Si Aplica)'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'favCUG',
			'value' => "",
			'type' => 'select',
			'label' => 'Seleccione Paquete Favoritos Compartidos'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'valorFavCUG',
			'value' => "",
			'type' => 'select',
			'label' => 'Seleccione Valor (Si Aplica)'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'favTigo',
			'value' => "",
			'type' => 'select',
			'label' => 'Seleccione Paquete Favoritos Tigo'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'valorFavTigo',
			'value' => "",
			'type' => 'select',
			'label' => 'Seleccione Valor (Si Aplica)'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'favTD',
			'value' => "",
			'type' => 'select',
			'label' => 'Seleccione Paquete Favoritos Todo Destino'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'valorFavTD',
			'value' => "",
			'type' => 'select',
			'label' => 'Seleccione Valor (Si Aplica)'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'smsTD',
			'value' => "",
			'type' => 'select',
			'label' => 'Seleccione Paquete SMS Todo Destino)'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'valorSmsTD',
			'value' => "",
			'type' => 'select',
			'label' => 'Seleccione Valor (Si Aplica)'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'smsTigo',
			'value' => "",
			'type' => 'select',
			'label' => 'Seleccione Paquete SMS Tigo'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'valorSmsTigo',
			'value' => "",
			'type' => 'select',
			'label' => 'Seleccione Valor (Si Aplica)'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'sinEmpaquetar',
			'value' => "",
			'type' => 'radio',
			'label' => 'Seleccionar si quedan Recursos sin Empaquetar'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'valorNoPack',
			'value' => "",
			'type' => 'radio',
			'label' => 'Ingrese Valor (Si Aplica)'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'datos1',
			'value' => "",
			'type' => 'select',
			'label' => 'Seleccione Paquete de Navegacion'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'capacidad',
			'value' => "",
			'type' => 'select',
			'label' => 'Capacidad de Navegación'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'valorDatos1',
			'value' => "",
			'type' => 'select',
			'label' => 'Seleccione Valor (Si Aplica)'
		]);

		/* TODO */
		$doc = $this->item($doc, $items, [
			'key' => 'diaActivacion',
			'value' => $this->fecha_inicio,
			'type' => 'todayText',
			'label' => 'Día de Diligenciamiento'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'numeroDocumentoRepeat',
			'value' => $this->documento,
			'type' => 'number',
			'label' => 'Número Documento'
		]);

		$doc = $this->item($doc, $items, [
			'key' => 'movilRepeat',
			'value' => $this->msisdn,
			'type' => 'tel',
			'label' => 'Número Línea'
		]);
		
		$this->write($doc->saveXML());

	}

	public function write($xml){
		$fp = fopen($this->name_xml, 'w');
		fwrite($fp, $xml);
		fclose($fp);
	}

	public function item($doc, $parent, $array){
		$item = $doc->createElement('items');
		$item = $parent->appendChild($item);

		foreach ($array as $key => $value){
			$label = $doc->createElement($key);
			$label = $item->appendChild($label);

			$text = $doc->createTextNode($value);
			$label->appendChild($text);
		}
		return $doc;
	}
}
