<?php

namespace Drupal\transformation_activation\Plugin\rest\resource;

use Drupal\rest\ModifiedResourceResponse;
use Drupal\rest\Plugin\ResourceBase;
use Psr\Log\LoggerInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Symfony\Component\HttpKernel\Exception\AccessDeniedHttpException;
use Symfony\Component\HttpKernel\Exception\BadRequestHttpException;
use Symfony\Component\HttpKernel\Exception\UnprocessableEntityHttpException;
use Drupal\transformation_activation\Activation;


/**
 * Provides a edit Properties Rest
 *
 * @RestResource(
 *   id = "callback_transformation_activation",
 *   label = @Translation("Callback Tigo Activation Rest"),
 *   uri_paths = {
 *     "https://www.drupal.org/link-relations/create" = "/tigo/callback-tigo-activation"
 *   }
 * )
 */


class CallbackTigoActivation extends ResourceBase
{

    /**
     * Responds to POST requests.
     */
    public function post($json) {
		if($json['transactionResponse']['transactionId'] && $json['transactionResponse']['responseCode']){

			Activation::CallBackActivation(
				$json['transactionResponse']['transactionId'],
				$json['transactionResponse']['responseCode'],
				$json['transactionResponse']['msisdn'],
				$json['transactionResponse']['description']
			);

			$res = ['Se actualizo correctamente el estado'];
			return new ModifiedResourceResponse($res, 200);
		}

		$res = ['No se enviaron los datos correctamente'];
		return new ModifiedResourceResponse($res, 500);

    }
}