<?php
/**
 * Created by PhpStorm.
 * User: andres
 * Date: 17/07/18
 * Time: 09:27 AM
 */

namespace Drupal\transformation_activation;

class SecurityQuestion
{
    /* Attributes */
    private $id;
    private $num_question;
    private $question;
    private $result;

    public function __construct($num_question) {
        $questions = $_SESSION['security_question'];
        $this->num_question = $num_question;
        $this->id = isset($questions[$num_question]->id) 
            ? $questions[$num_question]->id
            : FALSE;
        $query = db_select('transformation_activation_security_questions', 'sc');
        $query->addField('sc', 'question');
        $query->addField('sc', 'answer');
        $query->addField('sc', 'number');
        $query->addField('sc', 'path');
        $query->condition('sc.id', $this->id, '=');
        $this->result = $query->execute()->fetchObject();
        $this->question = $this->result->question;
    }

    public function Question(){
        return $this->question;
    }

    public function GenerateOptions(){
        if(!isset($_SESSION['security_question_' . $this->num_question]) 
            || empty($_SESSION['security_question_' . $this->num_question]))
            {
            
            $respuestas[] = $this->value_vtex_order($this->result->path);
            $real_answer = $respuestas[0];

            if($this->result->number 
            && preg_match('/[0-9]/i', $real_answer)){
                $re = '/[0-9]/m';
                $respuestas[] = preg_replace_callback(
                    $re, 
                    function($matches){ 
                        return rand(1, 9); 
                    }, 
                    $real_answer
                );
            }
            $cant = isset($respuestas[1]) 
                ? 1
                : 2;

            $exp_answer = explode("\r\n", trim($this->result->answer));


            $rand = array_rand($exp_answer, $cant);
            if($cant == 1){
                $rand = [
                    $rand
                ];
            }
            
            //similar_text
            $similar = FALSE;
            foreach ($rand as $rval){
                similar_text($exp_answer[$rval], $real_answer, $percent);
                if($percent > 80){
                    $similar = $rval;
                    break;
                }
            }

            if($similar){
                unset($exp_answer[$similar]);
                $rand = array_rand($exp_answer, $cant);
            }

            foreach ($rand as $rval){
                $respuestas[] = $exp_answer[$rval];
            }
            
            shuffle($respuestas);
            $_SESSION['security_question_' . $this->num_question] = $respuestas;
            foreach($respuestas as $key => $respuesta){
                if($respuesta == $real_answer){
                    $_SESSION['security_answer_' . $this->num_question] = $key;
                    break;
                }
            }
        }
        return $_SESSION['security_question_' . $this->num_question];

    }

    public function value_vtex_order($path){
        $info = $_SESSION['data_pospago'];
        $service = \Drupal::service('tigo_vtex_api.vtex_call');
        $json = $service->vtexOrderId($info['moreData']['real_order_id']);
        
        $new_json = (array) json_decode($json);

		$explode = explode('->', $path);
		foreach($explode as $value){
			if(isset($new_json[$value])){
                $new_json =  (array) $new_json[$value];
			}			
        }
        $return = FALSE;
        if(!empty($new_json[0])){
            $return = $new_json[0];
        }
        return $return;
    }
}