<?php
namespace Drupal\transformation_activation\Services;

use Drupal\tigoapi\TigoApi;

/**
 * Class TigoActivation
 * @package Drupal\transformation_activation\Services
 */
class TigoActivationStatus {

	private $response = null;

	// TigoApi Object for service request's
	protected $api;


	/**
	* {@inheritdoc}
	*/
	public function __construct(TigoApi $api) {
		$this->api = $api;
	}

	public function getResponse(){
		return $this->response;
	}

	/**
	* @param $data
	*/
	public function activationStatus($data) {

		// Build service parameters
		$params = [
			'headers' => [
				'Authorization' => 'basic ' . base64_encode('ecommerce:3c0mm3rce.T1g0.2018')
			],
			'tokens' => [
				'transactionId' => $data['transactionId']
			]
		];

		// Service consumption
		try {
			$this->response = $this->api->consumption('activations_status', $params, TRUE, FALSE, FALSE);
			\Drupal::logger('response')->notice(print_r($this->response, 1));
		}
		catch(\Exception $e) {
			$this->response = $e;
			\Drupal::logger('exception')->error(print_r($e->getMessage(), 1));
		}
		return $this;
  }
}