<?php

namespace Drupal\transformation_activation\Step;

use Drupal\transformation_activation\Button\StepOneNextButton;
use Drupal\transformation_activation\Validator\ValidatorRequired;
use Drupal\transformation_activation\SecurityQuestion;

/**
 * Class StepOne.
 *
 * @package Drupal\transformation_activation\Step
 */
class StepOne extends BaseStep {

  /**
   * {@inheritdoc}
   */
  protected function setStep() {
    return StepsEnum::STEP_ONE;
  }

  /**
   * {@inheritdoc}
   */
  public function getButtons() {
    return [
      new StepOneNextButton(),
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function buildStepFormElements() {
    $question = new SecurityQuestion(0);
    $options = $question->GenerateOptions();
    $form['label_1'] = [
      '#markup' => '<div class="step-on"><span>1</span>/3</div>'
    ];
    $form['question_0'] = [
      '#type' => 'radios',
      '#title' => $question->Question(),
      '#options' => $options,
      '#default_value' => isset($this->getValues()['question_0']) ? $this->getValues()['question_0'] : NULL,
    ];

    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function getFieldNames() {
    return [
      'question_0',
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function getFieldsValidators() {
    return [
      'question_0' => [
        new ValidatorRequired("Debe seleccionar una respuesta"),
      ],
    ];
  }

}
