<?php

namespace Drupal\transformation_activation\Step;

use Drupal\transformation_activation\Button\StepThreeFinishButton;
use Drupal\transformation_activation\Button\StepThreePreviousButton;
use Drupal\transformation_activation\Validator\ValidatorRequired;
use Drupal\transformation_activation\SecurityQuestion;

/**
 * Class StepThree.
 *
 * @package Drupal\transformation_activation\Step
 */
class StepThree extends BaseStep {

  /**
   * {@inheritdoc}
   */
  protected function setStep() {
    return StepsEnum::STEP_THREE;
  }

  /**
   * {@inheritdoc}
   */
  public function getButtons() {
    return [
      new StepThreeFinishButton(),
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function buildStepFormElements() {

    $question = new SecurityQuestion(2);
    $options = $question->GenerateOptions();
    $form['label_3'] = [
      '#markup' => '<div class="step-on"><span>3</span>/3</div>'
    ];
    $form['question_2'] = [
      '#type' => 'radios',
      '#title' => $question->Question(),
      '#options' => $options,
      '#default_value' => isset($this->getValues()['question_2']) ? $this->getValues()['question_2'] : NULL,
    ];

    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function getFieldNames() {
    return [
      'question_2',
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function getFieldsValidators() {
    return [
      'question_2' => [
        new ValidatorRequired("Debe seleccionar una respuesta")
      ],
    ];
  }

}
