<?php

namespace Drupal\transformation_activation\Step;

use Drupal\transformation_activation\Button\StepTwoNextButton;
use Drupal\transformation_activation\Button\StepTwoPreviousButton;
use Drupal\transformation_activation\Validator\ValidatorRequired;
use Drupal\transformation_activation\SecurityQuestion;

/**
 * Class StepTwo.
 *
 * @package Drupal\transformation_activation\Step
 */
class StepTwo extends BaseStep {

  /**
   * {@inheritdoc}
   */
  protected function setStep() {
    return StepsEnum::STEP_TWO;
  }

  /**
   * {@inheritdoc}
   */
  public function getButtons() {
    return [
      new StepTwoNextButton(),
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function buildStepFormElements() {
    $question = new SecurityQuestion(1);
    $options = $question->GenerateOptions();
    $form['label_2'] = [
      '#markup' => '<div class="step-on"><span>2</span>/3</div>'
    ];
    $form['question_1'] = [
      '#type' => 'radios',
      '#title' => $question->Question(),
      '#options' => $options,
      '#default_value' => isset($this->getValues()['question_1']) ? $this->getValues()['question_1'] : NULL,
    ];

    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function getFieldNames() {
    return [
      'question_1',
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function getFieldsValidators() {
    return [
      'question_1' => [
        new ValidatorRequired("Debe seleccionar una respuesta"),
      ],
    ];
  }

}
