<?php

namespace Drupal\transformation_activation;

class OS
{
    //Atributes
    private $user_agent = null;

    /**
     * Determination OS
     * @returns String Return the name of the OS
     */
    public static function os()
    {
        $user_agent = $_SERVER["HTTP_USER_AGENT"];
        $temp = null;
        
        $platform = array(
            "Windows 8"     => "Windows NT 6.2+",
            "Windows 7"     => "Windows NT 6.1+",
            "Windows Vista" => "Windows NT 6.0+",
            "Windows XP"    => "Windows NT 5.1+",
            "Windows 2003"  => "Windows NT 5.2+",
            "Windows"       => "Windows",
            "Windows Phone" => "Windows Phone",
            "iPhone"        => "iPhone",
            "iPad"          => "iPad",
            "iPod"          => "iPod",
            "Mac OS X"      => "(Mac OS X+)|(CFNetwork+)",
            "Mac"           => "Macintosh",
            "Android"       => "Android",
            "BlackBerry"    => "BlackBerry",
            "Linux"         => "Linux"
        );

        foreach ($platform as $key => $value) {
            if (preg_match("/" . $value . "/i", $user_agent)) {
                $temp = $key;
                break;
            }
        }
        
        return $temp;
    }
    
    /**
     * Determination is mobile or tablet
     * @returns Boolean True is mobile or tablet, false otherwise
     */
    public static function isMobil()
    {
        $os = self::os();
        
        $mobiles = array(
            "iPhone",
            "iPad",
            "iPod",
            "Android",
            "Windows Phone",
            "BlackBerry"
        );
        
        $temp = false;
        
        foreach ($mobiles as $value) {
            if ($value === $os) {
                $temp = true;
                break;
            }
        }
         
        return $temp;
    }
}